/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  struct f_path_mask *tt;
  for (tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}


/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from ../../proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}


#line 705 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    NMA = 277,
    DEFINE = 278,
    ON = 279,
    OFF = 280,
    YES = 281,
    NO = 282,
    S = 283,
    MS = 284,
    US = 285,
    PORT = 286,
    LOG = 287,
    SYSLOG = 288,
    ALL = 289,
    DEBUG = 290,
    TRACE = 291,
    INFO = 292,
    REMOTE = 293,
    WARNING = 294,
    ERROR = 295,
    AUTH = 296,
    FATAL = 297,
    BUG = 298,
    STDERR = 299,
    SOFT = 300,
    TIMEFORMAT = 301,
    ISO = 302,
    OLD = 303,
    SHORT = 304,
    LONG = 305,
    BASE = 306,
    NAME = 307,
    CONFIRM = 308,
    UNDO = 309,
    CHECK = 310,
    TIMEOUT = 311,
    LATENCY = 312,
    LIMIT = 313,
    WATCHDOG = 314,
    CONFIGURE = 315,
    DOWN = 316,
    KERNEL = 317,
    PERSIST = 318,
    SCAN = 319,
    TIME = 320,
    LEARN = 321,
    DEVICE = 322,
    ROUTES = 323,
    GRACEFUL = 324,
    RESTART = 325,
    KRT_SOURCE = 326,
    KRT_METRIC = 327,
    MERGE = 328,
    PATHS = 329,
    TABLE = 330,
    METRIC = 331,
    KRT_PREFSRC = 332,
    KRT_REALM = 333,
    KRT_SCOPE = 334,
    KRT_MTU = 335,
    KRT_WINDOW = 336,
    KRT_RTT = 337,
    KRT_RTTVAR = 338,
    KRT_SSTRESH = 339,
    KRT_CWND = 340,
    KRT_ADVMSS = 341,
    KRT_REORDERING = 342,
    KRT_HOPLIMIT = 343,
    KRT_INITCWND = 344,
    KRT_RTO_MIN = 345,
    KRT_INITRWND = 346,
    KRT_QUICKACK = 347,
    KRT_LOCK_MTU = 348,
    KRT_LOCK_WINDOW = 349,
    KRT_LOCK_RTT = 350,
    KRT_LOCK_RTTVAR = 351,
    KRT_LOCK_SSTRESH = 352,
    KRT_LOCK_CWND = 353,
    KRT_LOCK_ADVMSS = 354,
    KRT_LOCK_REORDERING = 355,
    KRT_LOCK_HOPLIMIT = 356,
    KRT_LOCK_RTO_MIN = 357,
    KRT_FEATURE_ECN = 358,
    KRT_FEATURE_ALLFRAG = 359,
    ROUTER = 360,
    ID = 361,
    PROTOCOL = 362,
    TEMPLATE = 363,
    PREFERENCE = 364,
    DISABLED = 365,
    DIRECT = 366,
    INTERFACE = 367,
    IMPORT = 368,
    EXPORT = 369,
    FILTER = 370,
    NONE = 371,
    VRF = 372,
    STATES = 373,
    FILTERS = 374,
    RECEIVE = 375,
    ACTION = 376,
    WARN = 377,
    BLOCK = 378,
    DISABLE = 379,
    KEEP = 380,
    FILTERED = 381,
    PASSWORD = 382,
    FROM = 383,
    PASSIVE = 384,
    TO = 385,
    EVENTS = 386,
    PACKETS = 387,
    PROTOCOLS = 388,
    INTERFACES = 389,
    ALGORITHM = 390,
    KEYED = 391,
    HMAC = 392,
    MD5 = 393,
    SHA1 = 394,
    SHA256 = 395,
    SHA384 = 396,
    SHA512 = 397,
    PRIMARY = 398,
    STATS = 399,
    COUNT = 400,
    FOR = 401,
    COMMANDS = 402,
    PREEXPORT = 403,
    NOEXPORT = 404,
    GENERATE = 405,
    ROA = 406,
    LISTEN = 407,
    BGP = 408,
    V6ONLY = 409,
    DUAL = 410,
    ADDRESS = 411,
    PASSWORDS = 412,
    DESCRIPTION = 413,
    SORTED = 414,
    RELOAD = 415,
    IN = 416,
    OUT = 417,
    MRTDUMP = 418,
    MESSAGES = 419,
    RESTRICT = 420,
    MEMORY = 421,
    IGP_METRIC = 422,
    CLASS = 423,
    DSCP = 424,
    WAIT = 425,
    MAX = 426,
    FLUSH = 427,
    AS = 428,
    SHOW = 429,
    STATUS = 430,
    SUMMARY = 431,
    ROUTE = 432,
    SYMBOLS = 433,
    ADD = 434,
    DELETE = 435,
    DUMP = 436,
    RESOURCES = 437,
    SOCKETS = 438,
    NEIGHBORS = 439,
    ATTRIBUTES = 440,
    EVAL = 441,
    ECHO = 442,
    ENABLE = 443,
    FUNCTION = 444,
    PRINT = 445,
    PRINTN = 446,
    UNSET = 447,
    RETURN = 448,
    ACCEPT = 449,
    REJECT = 450,
    QUITBIRD = 451,
    INT = 452,
    BOOL = 453,
    IP = 454,
    PREFIX = 455,
    PAIR = 456,
    QUAD = 457,
    EC = 458,
    LC = 459,
    SET = 460,
    STRING = 461,
    BGPMASK = 462,
    BGPPATH = 463,
    CLIST = 464,
    ECLIST = 465,
    LCLIST = 466,
    IF = 467,
    THEN = 468,
    ELSE = 469,
    CASE = 470,
    TRUE = 471,
    FALSE = 472,
    RT = 473,
    RO = 474,
    UNKNOWN = 475,
    GENERIC = 476,
    GW = 477,
    NET = 478,
    MASK = 479,
    PROTO = 480,
    SOURCE = 481,
    SCOPE = 482,
    CAST = 483,
    DEST = 484,
    IFNAME = 485,
    IFINDEX = 486,
    LEN = 487,
    DEFINED = 488,
    CONTAINS = 489,
    RESET = 490,
    PREPEND = 491,
    FIRST = 492,
    LAST = 493,
    LAST_NONAGGREGATED = 494,
    MATCH = 495,
    ROA_CHECK = 496,
    EMPTY = 497,
    WHERE = 498,
    BFD = 499,
    MIN = 500,
    IDLE = 501,
    RX = 502,
    TX = 503,
    INTERVAL = 504,
    MULTIPLIER = 505,
    MULTIHOP = 506,
    NEIGHBOR = 507,
    DEV = 508,
    LOCAL = 509,
    AUTHENTICATION = 510,
    SIMPLE = 511,
    METICULOUS = 512,
    SESSIONS = 513,
    HOLD = 514,
    CONNECT = 515,
    RETRY = 516,
    KEEPALIVE = 517,
    STARTUP = 518,
    VIA = 519,
    NEXT = 520,
    HOP = 521,
    SELF = 522,
    DEFAULT = 523,
    PATH = 524,
    START = 525,
    DELAY = 526,
    FORGET = 527,
    AFTER = 528,
    BGP_PATH = 529,
    BGP_LOCAL_PREF = 530,
    BGP_MED = 531,
    BGP_ORIGIN = 532,
    BGP_NEXT_HOP = 533,
    BGP_ATOMIC_AGGR = 534,
    BGP_AGGREGATOR = 535,
    BGP_COMMUNITY = 536,
    BGP_EXT_COMMUNITY = 537,
    RR = 538,
    RS = 539,
    CLIENT = 540,
    CLUSTER = 541,
    AS4 = 542,
    ADVERTISE = 543,
    IPV4 = 544,
    CAPABILITIES = 545,
    PREFER = 546,
    OLDER = 547,
    MISSING = 548,
    LLADDR = 549,
    DROP = 550,
    IGNORE = 551,
    REFRESH = 552,
    INTERPRET = 553,
    COMMUNITIES = 554,
    BGP_ORIGINATOR_ID = 555,
    BGP_CLUSTER_LIST = 556,
    IGP = 557,
    GATEWAY = 558,
    RECURSIVE = 559,
    MED = 560,
    TTL = 561,
    SECURITY = 562,
    DETERMINISTIC = 563,
    SECONDARY = 564,
    ALLOW = 565,
    AWARE = 566,
    LINK = 567,
    EXTENDED = 568,
    SETKEY = 569,
    BGP_LARGE_COMMUNITY = 570,
    LIVED = 571,
    STALE = 572,
    CEASE = 573,
    HIT = 574,
    ADMINISTRATIVE = 575,
    SHUTDOWN = 576,
    PEER = 577,
    CONFIGURATION = 578,
    CHANGE = 579,
    DECONFIGURED = 580,
    CONNECTION = 581,
    REJECTED = 582,
    COLLISION = 583,
    OF = 584,
    MRT = 585,
    FILENAME = 586,
    PERIOD = 587,
    ALWAYS = 588,
    OSPF = 589,
    AREA = 590,
    OSPF_METRIC1 = 591,
    OSPF_METRIC2 = 592,
    OSPF_TAG = 593,
    OSPF_ROUTER_ID = 594,
    RFC1583COMPAT = 595,
    STUB = 596,
    TICK = 597,
    COST = 598,
    COST2 = 599,
    RETRANSMIT = 600,
    HELLO = 601,
    TRANSMIT = 602,
    PRIORITY = 603,
    DEAD = 604,
    TYPE = 605,
    BROADCAST = 606,
    BCAST = 607,
    NONBROADCAST = 608,
    NBMA = 609,
    POINTOPOINT = 610,
    PTP = 611,
    POINTOMULTIPOINT = 612,
    PTMP = 613,
    STRICT = 614,
    CRYPTOGRAPHIC = 615,
    ELIGIBLE = 616,
    POLL = 617,
    NETWORKS = 618,
    HIDDEN = 619,
    VIRTUAL = 620,
    ONLY = 621,
    BUFFER = 622,
    LARGE = 623,
    NORMAL = 624,
    STUBNET = 625,
    TAG = 626,
    EXTERNAL = 627,
    LSADB = 628,
    ECMP = 629,
    WEIGHT = 630,
    NSSA = 631,
    TRANSLATOR = 632,
    STABILITY = 633,
    GLOBAL = 634,
    LSID = 635,
    INSTANCE = 636,
    REAL = 637,
    NETMASK = 638,
    LENGTH = 639,
    LSA = 640,
    SUPPRESSION = 641,
    TOPOLOGY = 642,
    STATE = 643,
    PIPE = 644,
    MODE = 645,
    OPAQUE = 646,
    TRANSPARENT = 647,
    RIP = 648,
    INFINITY = 649,
    UPDATE = 650,
    GARBAGE = 651,
    MULTICAST = 652,
    VERSION = 653,
    SPLIT = 654,
    HORIZON = 655,
    POISON = 656,
    REVERSE = 657,
    ZERO = 658,
    PLAINTEXT = 659,
    RIP_METRIC = 660,
    RIP_TAG = 661,
    STATIC = 662,
    PROHIBIT = 663,
    MULTIPATH = 664,
    BLACKHOLE = 665,
    UNREACHABLE = 666
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 634 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct mrt_dump_data *md;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1187 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1204 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  72
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3556

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  433
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  278
/* YYNRULES -- Number of rules.  */
#define YYNRULES  993
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1896

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   666

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     424,   425,    29,    27,   429,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   426,   423,
      23,    22,    24,   430,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   431,     2,   432,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   427,     2,   428,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   841,   841,   842,   845,   847,   855,   864,   865,   866,
     873,   874,   875,   883,   884,   885,   886,   887,   888,   894,
     895,   902,   903,   907,   914,   915,   919,   923,   930,   938,
     939,   946,   947,   951,   952,   958,   967,   968,   972,   977,
     978,   982,   983,   987,   988,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1006,  1007,  1017,  1018,  1019,  1020,
    1023,  1024,  1025,  1026,  1027,  1028,  1032,  1038,  1039,  1040,
    1041,  1049,  1052,  1059,  1062,  1065,  1068,  1072,  1073,  1077,
    1078,  1079,  1087,  1092,  1093,  1097,  1098,  1102,  1109,  1110,
    1111,  1123,  1128,  1132,  1146,  1147,  1161,  1162,  1166,  1167,
    1168,  1169,  1176,  1190,  1192,  1194,  1198,  1199,  1200,  1201,
    1206,  1212,  1213,  1217,  1225,  1229,  1231,  1237,  1238,  1245,
    1246,  1250,  1256,  1260,  1269,  1278,  1280,  1284,  1285,  1286,
    1287,  1288,  1289,  1290,  1291,  1292,  1293,  1294,  1295,  1296,
    1300,  1301,  1302,  1303,  1307,  1308,  1309,  1310,  1311,  1315,
    1321,  1325,  1333,  1334,  1342,  1350,  1351,  1352,  1356,  1357,
    1361,  1366,  1367,  1371,  1373,  1381,  1385,  1386,  1392,  1399,
    1400,  1401,  1402,  1406,  1414,  1420,  1421,  1422,  1426,  1427,
    1431,  1432,  1433,  1434,  1435,  1436,  1442,  1443,  1444,  1448,
    1449,  1453,  1454,  1460,  1461,  1464,  1466,  1470,  1471,  1475,
    1495,  1496,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1507,
    1508,  1509,  1510,  1511,  1512,  1513,  1514,  1515,  1516,  1522,
    1525,  1528,  1531,  1535,  1536,  1539,  1542,  1546,  1550,  1555,
    1561,  1568,  1573,  1578,  1583,  1587,  1591,  1595,  1604,  1612,
    1616,  1623,  1624,  1625,  1630,  1634,  1641,  1648,  1652,  1660,
    1661,  1662,  1667,  1671,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1685,  1690,  1698,  1705,  1712,  1720,  1722,  1724,  1726,
    1728,  1730,  1732,  1734,  1737,  1741,  1747,  1748,  1749,  1753,
    1754,  1760,  1762,  1764,  1766,  1768,  1770,  1774,  1778,  1781,
    1785,  1786,  1787,  1791,  1792,  1793,  1801,  1801,  1811,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1851,  1862,  1863,  1870,  1871,  1878,
    1887,  1891,  1895,  1916,  1917,  1921,  1933,  1933,  1949,  1950,
    1953,  1954,  1958,  1961,  1970,  1983,  1984,  1985,  1986,  1987,
    1991,  1999,  2000,  2001,  2002,  2003,  2007,  2010,  2011,  2012,
    2013,  2014,  2015,  2016,  2017,  2018,  2019,  2024,  2025,  2026,
    2027,  2031,  2032,  2033,  2037,  2038,  2039,  2040,  2041,  2042,
    2043,  2044,  2049,  2050,  2051,  2052,  2053,  2057,  2058,  2059,
    2060,  2061,  2065,  2066,  2070,  2071,  2075,  2082,  2083,  2084,
    2085,  2092,  2093,  2096,  2097,  2104,  2116,  2117,  2121,  2122,
    2126,  2127,  2128,  2129,  2130,  2131,  2135,  2136,  2137,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,  2149,  2150,  2154,
    2155,  2156,  2157,  2167,  2171,  2193,  2205,  2206,  2207,  2208,
    2209,  2210,  2211,  2212,  2213,  2214,  2218,  2219,  2220,  2221,
    2222,  2223,  2224,  2225,  2226,  2227,  2228,  2229,  2230,  2231,
    2232,  2233,  2234,  2236,  2237,  2238,  2240,  2242,  2244,  2246,
    2247,  2248,  2249,  2250,  2251,  2261,  2262,  2263,  2264,  2265,
    2266,  2267,  2268,  2270,  2271,  2274,  2296,  2297,  2298,  2299,
    2300,  2301,  2305,  2308,  2309,  2310,  2318,  2324,  2332,  2333,
    2337,  2342,  2350,  2358,  2363,  2367,  2373,  2377,  2382,  2383,
    2384,  2391,  2392,  2393,  2394,  2395,  2401,  2413,  2414,  2415,
    2416,  2419,  2421,  2425,  2429,  2443,  2463,  2464,  2465,  2466,
    2467,  2468,  2469,  2470,  2474,  2475,  2476,  2477,  2478,  2479,
    2482,  2484,  2487,  2489,  2493,  2496,  2501,  2502,  2503,  2507,
    2508,  2512,  2513,  2516,  2535,  2541,  2568,  2570,  2571,  2576,
    2577,  2581,  2582,  2586,  2587,  2588,  2589,  2590,  2591,  2592,
    2593,  2594,  2598,  2599,  2600,  2601,  2602,  2603,  2609,  2610,
    2611,  2612,  2613,  2614,  2615,  2616,  2617,  2618,  2619,  2620,
    2621,  2622,  2623,  2624,  2625,  2626,  2627,  2628,  2629,  2630,
    2631,  2632,  2633,  2634,  2635,  2636,  2637,  2638,  2639,  2640,
    2641,  2642,  2643,  2644,  2645,  2646,  2647,  2648,  2654,  2655,
    2656,  2657,  2658,  2659,  2660,  2661,  2662,  2663,  2664,  2665,
    2666,  2667,  2668,  2669,  2670,  2671,  2672,  2673,  2684,  2690,
    2691,  2692,  2693,  2694,  2695,  2696,  2699,  2701,  2705,  2708,
    2712,  2713,  2714,  2715,  2716,  2717,  2724,  2734,  2735,  2739,
    2740,  2741,  2742,  2743,  2744,  2745,  2746,  2747,  2750,  2765,
    2768,  2770,  2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,
    2782,  2783,  2783,  2784,  2784,  2785,  2786,  2787,  2791,  2792,
    2796,  2804,  2806,  2810,  2811,  2812,  2816,  2817,  2820,  2822,
    2825,  2826,  2827,  2828,  2829,  2830,  2831,  2832,  2833,  2834,
    2835,  2838,  2858,  2859,  2860,  2861,  2862,  2863,  2864,  2865,
    2866,  2867,  2868,  2869,  2870,  2871,  2872,  2873,  2874,  2875,
    2876,  2877,  2878,  2879,  2880,  2881,  2882,  2883,  2884,  2885,
    2886,  2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,  2895,
    2896,  2899,  2901,  2904,  2906,  2915,  2917,  2918,  2921,  2923,
    2927,  2928,  2931,  2941,  2962,  2964,  2968,  2968,  2971,  2973,
    2976,  2978,  2982,  2987,  2990,  2993,  2998,  3001,  3006,  3009,
    3013,  3017,  3020,  3021,  3022,  3023,  3024,  3025,  3026,  3027,
    3033,  3040,  3041,  3042,  3047,  3048,  3054,  3067,  3068,  3069,
    3070,  3071,  3074,  3076,  3080,  3084,  3107,  3137,  3138,  3139,
    3140,  3141,  3142,  3143,  3147,  3148,  3149,  3150,  3151,  3152,
    3153,  3154,  3155,  3156,  3157,  3158,  3159,  3160,  3161,  3162,
    3163,  3164,  3168,  3169,  3170,  3171,  3174,  3176,  3179,  3181,
    3185,  3191,  3194,  3201,  3208,  3209,  3210,  3211,  3212,  3215,
    3225,  3234,  3238,  3244,  3245,  3249,  3254,  3260,  3263,  3268,
    3269,  3270,  3271,  3272,  3276,  3277,  3280,  3282,  3285,  3287,
    3291,  3298,  3298,  3298,  3298,  3298,  3298,  3298,  3298,  3298,
    3298,  3298,  3298,  3298,  3298,  3298,  3298,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,  3299,
    3299,  3299,  3299,  3299,  3299,  3299,  3299,  3300,  3300,  3300,
    3300,  3300,  3300,  3300,  3300,  3300,  3300,  3301,  3301,  3301,
    3301,  3302,  3302,  3302,  3303,  3303,  3303,  3303,  3303,  3303,
    3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,
    3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,  3303,
    3303,  3303,  3303,  3303,  3303,  3304,  3304,  3305,  3306,  3307,
    3308,  3309,  3310,  3311,  3312,  3313,  3314,  3315,  3316,  3316,
    3316,  3316,  3316,  3316
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "VRF", "STATES",
  "FILTERS", "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP",
  "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1",
  "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "BGP_LARGE_COMMUNITY", "LIVED", "STALE", "CEASE",
  "HIT", "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT",
  "FILENAME", "PERIOD", "ALWAYS", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA", "SUPPRESSION",
  "TOPOLOGY", "STATE", "PIPE", "MODE", "OPAQUE", "TRANSPARENT", "RIP",
  "INFINITY", "UPDATE", "GARBAGE", "MULTICAST", "VERSION", "SPLIT",
  "HORIZON", "POISON", "REVERSE", "ZERO", "PLAINTEXT", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa", "pxlen",
  "datetime", "text", "opttext", "text_or_none", "log_config",
  "syslog_name", "log_file", "log_mask", "log_mask_list", "log_cat",
  "mrtdump_base", "timeformat_which", "timeformat_spec", "timeformat_base",
  "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start",
  "kern_mp_limit", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def",
  "$@1", "filter_eval", "type", "one_decl", "decls", "declsn",
  "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_nbr_opts",
  "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag", "bgp_proto",
  "mrt_proto_start", "mrt_proto_item", "mrt_proto_opts", "mrt_proto",
  "cmd_MRT_DUMP", "mrt_dump_args", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_proto_start",
  "rip_proto_item", "rip_proto_opts", "rip_proto", "rip_iface_start",
  "rip_iface_finish", "rip_iface_item", "rip_auth", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface", "cmd_SHOW_RIP_INTERFACES",
  "cmd_SHOW_RIP_NEIGHBORS", "static_proto_start", "static_proto",
  "stat_route0", "stat_multipath1", "stat_multipath", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "conf", "cli_cmd", "proto", "kern_proto", "kif_proto",
  "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,    59,    40,    41,    58,   123,   125,    44,
      63,    91,    93
};
# endif

#define YYPACT_NINF -1523

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1523)))

#define YYTABLE_NINF -489

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-489)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      97,  3215,   175,   782,   646,   982,   186,   646,   646,   798,
     646,   224,   110,   924,   130,   139,  1030,  1851,   161,   646,
     148, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,   345,   804,   398,   749,   559,   303,
     374,   379, -1523, -1523,   401,   476,   426,   399,  1851,   605,
   -1523, -1523, -1523, -1523, -1523, -1523,    87,    87, -1523, -1523,
   -1523, -1523,   218, -1523,   993, -1523,    87,  3053, -1523, -1523,
   -1523,    87, -1523,    87,  2831,    87, -1523,    87,  2857,    87,
    3069,    87, -1523,    87,  2904, -1523, -1523,  2735,  3100, -1523,
   -1523, -1523,   162, -1523,   633,   684,   699,   633,   651, -1523,
     737,   737,   646,   646,   757,   195, -1523,   686,   916,   100,
   -1523,   783,   805, -1523, -1523,   546,   286,   373,   830,   567,
     567,   848,   855,   881,   886,   889,   891,   900,   902,   103,
   -1523, -1523, -1523,   833,   496, -1523,   669,    50,    26,  1851,
   -1523,   509,   519,   527, -1523, -1523,   529,   531,   538,  1061,
     124, -1523, -1523, -1523, -1523, -1523,  2417, -1523,  2760, -1523,
   -1523,  1952,   953,   737, -1523,   951, -1523, -1523,   912, -1523,
   -1523,     8,   222,   162,   259, -1523, -1523, -1523, -1523,   467,
     555,   259,   259,   802,   811,   193, -1523,   986, -1523,   195,
     580,  2984, -1523,   876,  1015,   602,   609, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,   617,   162,
     742,  1044,   956,   259,   842, -1523,   484,   871,   643,  1028,
     643,   195, -1523,   677,   688,   665,   687,    -8,   789,   799,
    1043,   703,  1115,   854,   643,   842,  1074,  1076,   310,   996,
     740,   142,   567,   339,  1092,   279,  1095,   903,   899,   430,
    1091,   915,   433,   914,   911,   842,   909,   908,   905,   660,
     -66,  1129,   904,   920,   842,   298,   842, -1523,   794,   791,
     815,   838,    98,   842,  1111,   259,   842,  1121, -1523, -1523,
     820,   818, -1523,   822,  1153,   419, -1523,   831,   826,   841,
     935,   567,  1179, -1523,   849,   781,   844,  1187,   842,  1207,
     842,  1205,  1206,  1201,   259, -1523,   872,   873,   874,  1223,
     737, -1523,   888,   893, -1523, -1523,  1011,  1301,   651, -1523,
   -1523,  1306,   259,  1309, -1523,  1311,  1315,  1316,  1317, -1523,
   -1523, -1523,   232,  1321,  1308,  1326, -1523, -1523,   851,  1328,
   -1523,  1340,   800, -1523, -1523,  3285,   788,   830, -1523,   830,
     830, -1523,   301,   346,  1341,   830,   830,  1343, -1523, -1523,
      25,  1165,  1166, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,    23, -1523,   103,  1851,   103,   103,  1335, -1523,  1336,
    1337,  1331,   181,  1332,    26,    26,  1329,  1333,  1851,  1851,
    1851,  1851,  1851,  1349, -1523, -1523,  1347, -1523,   947,    64,
   -1523, -1523, -1523, -1523,  1003, -1523,  1372, -1523, -1523, -1523,
   -1523,    53,    68, -1523,   198, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1851,  1851,
    1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,  1851,
    1851,  1851,  1135, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,   520, -1523, -1523,  1377,  1378,   615,  1851,   643,
   -1523, -1523,  1952,   965, -1523, -1523, -1523, -1523, -1523, -1523,
     259,  1851, -1523, -1523, -1523, -1523,   259,   898,   925, -1523,
     573, -1523, -1523,   259, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,  1851,   967,  2427, -1523,    77,   968, -1523,   970,  1373,
   -1523, -1523, -1523,   -98, -1523, -1523,   842, -1523, -1523,    98,
   -1523, -1523, -1523, -1523,   389,  3103, -1523,  1258,  1851, -1523,
   -1523,   389, -1523, -1523,   389, -1523, -1523, -1523, -1523, -1523,
   -1523,  1320,  1323,    48,   842,   217, -1523,   983,    12,   985,
     987,   259,   287,  1099,   842,  1241,   567,   995,   997, -1523,
    1008,  1388,   -13,   259,  1249,   259,  1368,  1371,   259,  1379,
      -7,   259,   259,   842,  1380,  1025,  1344,  1026,   842,  1037,
     842,   299,   842,  1044,   842,  1050,  1051,   842,   842,   842,
    1055,  1278,   842,  1056, -1523, -1523, -1523,   842, -1523, -1523,
     842, -1523,  1411,   259, -1523, -1523, -1523,  1463,  1068,  1070,
   -1523, -1523, -1523,   842, -1523,  1044, -1523, -1523,   946, -1523,
     567, -1523,  1219, -1523, -1523, -1523,  1073,   259, -1523,   259,
   -1523,   842,   842,   842, -1523, -1523, -1523, -1523,   259,   567,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,   572, -1523,
   -1523,  1495, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,   611, -1523, -1523, -1523, -1523,  1496, -1523, -1523, -1523,
    1481, -1523, -1523,  1489,   567, -1523, -1523,  1487,  1488, -1523,
    3103, -1523, -1523, -1523, -1523,   567, -1523, -1523, -1523,  1493,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1505,
    1497,  1497,   816,   830,  1497,   830,  1497, -1523,  1497,  1497,
   -1523,   259,   567, -1523,  1500,  1501,  1503, -1523, -1523,   901,
   -1523, -1523, -1523, -1523,   158, -1523,  1094, -1523,  1269,  1498,
   -1523, -1523, -1523, -1523,   192,   344,   570,   984,   670,   333,
   -1523,  1851, -1523,  1851,  1096,    21,  1100,  1122,   177,   265,
   -1523, -1523, -1523,  1508,  1506, -1523,  2544,  2544,  2544,  3339,
    3339,  2544,  2544,  2544,  2544,  2544,   812,   812,  1333,  1333,
   -1523,  1110, -1523, -1523, -1523, -1523, -1523,  1952, -1523, -1523,
   -1523,  1023,  3103,   643, -1523,  1442, -1523,   631, -1523, -1523,
    1252,  1515, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1116,
   -1523,  1118,  1413, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,   102,  1120,
    1119, -1523, -1523,   259, -1523, -1523,   567, -1523, -1523, -1523,
    2327,  2427, -1523,   567, -1523,  1125, -1523,  1510, -1523,  1124,
   -1523,  1417, -1523, -1523, -1523, -1523,   842,  2984, -1523, -1523,
    2993,   259,   259,  1475,  1484,  1134,   259,  1138,  1139, -1523,
     842,    47, -1523, -1523,  1140,  1144,  1145,  1150,   842,  1151,
     842,  1154, -1523, -1523, -1523,  1561, -1523,   259,   259, -1523,
    1160,   259,  1163,   259,   259,  1164,   259,  1167,  1168,  1169,
    1170,  1171,   259, -1523,    98, -1523,  1172, -1523,  1173,  1175,
    1176,  1178,  1185,  1186,  1188, -1523, -1523,  1195,  1197,  1198,
   -1523,   366,  1199, -1523,  2929, -1523, -1523,   259, -1523,   949,
    1200, -1523, -1523,  2715,  1204,  1208, -1523,  1388, -1523,   567,
    -124,  1219,  2377, -1523, -1523, -1523, -1523, -1523,  1541, -1523,
      25, -1523, -1523, -1523,  1011, -1523, -1523,   232, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1625,
    1630, -1523, -1523,    98, -1523, -1523,    98,  1619, -1523,    98,
    1497,  1632,  1497,  1635,  1636,  1637, -1523, -1523,  1452,  1470,
     103, -1523,  1851, -1523,  1627,  1628,  1851,  1851,  1851, -1523,
    1851, -1523,  1851,   698,   125,  1385,  1851,  1587,  1851, -1523,
   -1523,  1851, -1523, -1523,  1218,   833, -1523,  1851, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1124, -1523,
   -1523, -1523, -1523,  2427,  2514, -1523, -1523, -1523,  1235,  1237,
   -1523,  1482, -1523, -1523,  1007, -1523,   731, -1523, -1523, -1523,
   -1523,   567, -1523, -1523,  1243,  1238,  1245,   364,   259, -1523,
    1246, -1523, -1523,  1247,   969, -1523,  1248, -1523, -1523, -1523,
   -1523,  1250, -1523,  1251, -1523, -1523,    63, -1523, -1523, -1523,
    1253, -1523,  1255,  1256, -1523,  1257, -1523, -1523, -1523, -1523,
   -1523,  1260,  1261, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1262, -1523,  1063,  3103,   643,
     259,  1485, -1523, -1523, -1523,  1263, -1523, -1523,   842,  -131,
     522, -1523,  1358,   567, -1523, -1523,   600, -1523,  1267, -1523,
    1299, -1523, -1523,   842,   259, -1523, -1523,  1270, -1523, -1523,
   -1523,  1388,   842,   259,  -124,    45, -1523,  1670, -1523, -1523,
    1271,  1851, -1523, -1523, -1523,  1851,  1851,   842, -1523,  2417,
    1273,  1633, -1523, -1523,   259, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,  1691, -1523,  1695, -1523, -1523, -1523,
    1684,  1687, -1523, -1523,  1675, -1523,  1887,  1964,  2021,  2058,
     741,  1851, -1523,  1851,   409,    14,  2984,  1275,   411,    33,
    1276,  1122,  1693,  2109, -1523,  1281,    93, -1523,  2427, -1523,
    1696,   567, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,  1279, -1523,    69, -1523, -1523,   259, -1523,  1287,  1297,
    1298, -1523, -1523,  1382,  1654, -1523,   159,  1389,  1403,   746,
     674, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1444, -1523, -1523,
   -1523, -1523,   259,   259,   842,   259, -1523,  1312,    98, -1523,
   -1523,  1313,  1314,   259, -1523, -1523,   259,  1324, -1523, -1523,
    1673, -1523, -1523, -1523, -1523, -1523,  1851,  1337,  1851, -1523,
    2357,  2596,   772,  1327,  1721,   407, -1523,  2984,  1325,  1334,
   -1523, -1523, -1523,   686,   686,  1724, -1523, -1523, -1523, -1523,
    1851,  2135,  2161, -1523,  1726,  1851, -1523,  1699, -1523,  1727,
    1851,  1751,  1717,  1768,  1338, -1523, -1523, -1523, -1523,  1576,
   -1523,  1124,  1279, -1523, -1523,  1744,   643,  1499,  1342, -1523,
   -1523, -1523,  1586,  1459, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,   969,   842,  1124,  1355, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523,  1363,   259,  2383,  1366,
    2409,  2582, -1523,  1729, -1523, -1523,  1851,  1851,   727,  1633,
   -1523,  1789,  1790, -1523,  2192, -1523, -1523,  1369,  1374,   425,
      24,  1376,   513,  1381,  1383,    36,  1386,    38, -1523,  1787,
   -1523,   801, -1523, -1523, -1523,   567,  1542, -1523, -1523, -1523,
   -1523, -1523,  1299, -1523, -1523,    32,   365,    39,   809, -1523,
   -1523, -1523, -1523, -1523, -1523,  1387,  2514,  1578, -1523,    31,
    2439,  2465,  1393,  1394,  1396,  1397,  1384, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,  1777,  1851, -1523, -1523, -1523,  1781,
    1851, -1523,  1851,  1806, -1523,  1851, -1523,  1399, -1523,   643,
     842,  1400,   860,  1567,   259,   259,   393, -1523, -1523, -1523,
    1401,  1406, -1523,   842, -1523, -1523,  3023, -1523, -1523, -1523,
     241,   842,   259,   842, -1523,  1410, -1523,   259,   163,   259,
     259,  1548,   219, -1523, -1523,  1412,  2657, -1523,  1419,  1408,
    1729,   108, -1523, -1523, -1523,  1003, -1523, -1523,  1833, -1523,
   -1523, -1523, -1523,    90, -1523, -1523,  1851,  1851,  1851,  1851,
   -1523,  1420,  1422,  1426,  1415,  1428,  1431,  1432, -1523, -1523,
   -1523,  1725,  1599,  1602,  1612, -1523, -1523, -1523,   971, -1523,
    1728, -1523,   758, -1523, -1523,  1550,   259,  1447,   842,  1504,
     -15,   212,  1558,   842,  1490,   842,   259,   259,   259,  1605,
     259,   289,  1407,  1507,  1520,   259,  1514,  1529, -1523, -1523,
    1469, -1523,   259,  1479, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,   259,   259, -1523, -1523,   259,   -93,
    1817,   259,   842,   567,   842,  1525,   488,   -29,  1588,  1518,
      86,  1829,  1842,   449,  1511,  1512, -1523, -1523,  1516, -1523,
   -1523, -1523, -1523,  2218,   311,   108,   320,  2244,  2275,  2305,
    2331, -1523, -1523, -1523,  1851, -1523,  1851, -1523,  1491,  1517,
     259,   259,   259, -1523, -1523,  1010,   259,  1901,  1901,  1035,
     408,   536,  1509,   842, -1523, -1523, -1523,   363,   259,   259,
     259,   259, -1523, -1523, -1523, -1523,   613, -1523,  1526, -1523,
   -1523, -1523, -1523,   259, -1523,   259, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,   842,   842, -1523,   259,   842,
   -1523, -1523, -1523, -1523, -1523, -1523,   842,   842,   259, -1523,
   -1523, -1523, -1523,   259,   259,   259, -1523, -1523, -1523, -1523,
   -1523, -1523,   795,   259, -1523, -1523,   259,   259,   842, -1523,
     842,   842, -1523, -1523,  1851, -1523, -1523, -1523,  1519,  1524,
    1527,  1530,  1513,  1528, -1523,  1725, -1523, -1523, -1523, -1523,
   -1523,  1531, -1523,  1533,  1537,  1039,  1222,  1539,  1901,  1901,
    1901,  1901, -1523, -1523,    42, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,  1547, -1523,   842, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1551, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  2218, -1523, -1523, -1523, -1523,
   -1523,  1851, -1523,   758,   758,   758, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523,   758,  1540,  1543,  1544,
    1545, -1523,  1557, -1523, -1523, -1523, -1523,  1536, -1523, -1523,
   -1523, -1523,   758,   758,   758,   758, -1523,  1555,  1851, -1523,
   -1523, -1523, -1523, -1523,  1523, -1523
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   423,     0,     0,
       0,   877,   878,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   888,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
     916,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,     3,     1,     2,     0,     0,     0,     0,     0,     0,
       0,     0,   119,   120,     0,     0,     0,     0,   423,     0,
     861,   862,   863,   864,   865,   866,   121,   121,   867,   868,
     869,   870,   117,   871,     0,   873,   121,   125,   874,   875,
     876,   121,   930,   121,   125,   121,   932,   121,   125,   121,
     125,   121,   935,   121,   125,     5,   872,   125,   125,   290,
     292,   291,     0,    78,    77,     0,     0,    77,    79,    76,
      34,    34,     0,     0,     0,     0,   289,   261,   294,     0,
     245,     0,     0,   228,   253,     0,   224,     0,   224,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   405,
     409,   418,   415,   334,   425,   412,     0,     0,   408,   423,
     456,     0,     0,     0,   410,   411,     0,     0,     0,   423,
       0,   413,   414,   422,   454,   455,     0,   453,     0,   277,
     276,     0,   279,    34,   640,     0,    30,    29,    37,    40,
      38,     0,    18,     0,     0,    59,    58,    57,    56,     0,
       0,     0,     0,     0,   111,     0,   296,     0,   104,     0,
       0,   298,   326,   122,     0,     0,     0,   115,    82,    91,
     168,   545,   506,   628,   646,   780,   786,   833,     0,     0,
       0,     0,     0,     0,    18,   173,     0,     0,     0,     0,
       0,     0,   929,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
      18,     0,   546,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,    18,   931,     0,     0,
       0,     0,     0,    18,     0,     0,    18,     0,   933,   649,
       0,     0,   657,     0,     0,     0,   934,     0,     0,     0,
       0,     0,     0,   936,     0,     0,   858,     0,    18,     0,
      18,     0,     0,     0,     0,   927,     0,     0,     0,     0,
      34,   928,     0,     0,   176,   175,     0,     0,    79,    73,
      74,     0,    80,     0,    33,     0,     0,     0,     0,   284,
     187,   186,     0,     0,     0,     0,   293,   295,   294,     0,
     225,     0,   249,   220,   219,     0,     0,   224,   223,   224,
     224,   771,   224,   224,     0,   224,   224,     0,    19,    20,
       0,     0,     0,   272,   268,   273,   269,   266,   267,   270,
     271,   405,   425,   405,   423,   405,   405,     0,   396,     0,
     423,     0,     0,     0,   408,   408,     0,   451,   423,   423,
     423,   423,   423,     0,   357,   358,     0,   360,     0,     0,
     335,   338,   336,   340,   423,   337,   375,   372,   373,   374,
     382,     0,   387,   391,     0,   975,   944,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   959,   960,   961,   962,   963,   964,   965,   966,   967,
     968,   969,   970,   971,   972,   973,   426,   974,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   977,   980,   979,
     976,   978,   981,   982,   983,   986,   984,   985,   987,   988,
     989,   990,   991,   992,   993,   457,   458,   274,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,     0,    45,    46,    47,    48,    49,    50,    51,
      52,    53,     0,    43,   280,     0,     0,     0,   423,     0,
      39,    41,     0,     0,     7,     9,    14,    16,    15,    17,
       0,   423,    13,    67,   152,   153,    60,     0,     0,    66,
       0,    69,    70,     0,   112,   113,    98,   100,   101,   102,
     164,   423,     0,   315,   114,     0,     0,    55,     0,     0,
     123,   937,   941,     0,   169,   128,    18,   151,   137,     0,
     126,   127,   154,   142,     0,   315,   143,     0,   423,   130,
     141,     0,   131,   136,     0,   139,   129,   170,   171,   511,
     562,     0,     0,     0,    18,    18,   574,     0,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,     0,   575,
       0,    21,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
      18,     0,    18,     0,    18,     0,     0,    18,    18,    18,
       0,     0,    18,     0,   563,   636,   647,    18,   658,   650,
      18,   655,   652,     0,   648,   660,   781,     0,     0,     0,
     782,   792,   834,    18,   839,     0,   835,   850,     0,   849,
       0,   853,     0,   851,   852,   856,     0,     0,    85,     0,
      87,    18,    18,    18,    95,   939,   940,   938,     0,     0,
     943,   942,   181,   180,   182,   184,   185,   183,     0,   178,
     287,     0,    75,    81,    71,   283,   281,   285,   286,   191,
     192,     0,   189,   288,   262,   265,     0,   221,   226,   244,
       0,   251,   250,     0,     0,   227,   234,     0,     0,   242,
     315,   236,   235,   239,   240,     0,   241,   243,   229,     0,
     233,   252,   260,   254,   257,   258,   256,   259,   255,     0,
      32,    32,     0,   224,    32,   224,    32,   763,    32,    32,
     860,     0,     0,    23,     0,     0,     0,   400,   402,     0,
     403,   404,   398,   386,   486,   489,     0,   465,     0,     0,
     466,   406,   407,   399,     0,     0,     0,     0,     0,     0,
     359,   423,   436,   423,     0,     0,     0,   346,     0,     0,
     416,   388,   389,     0,     0,   417,   448,   446,   444,   441,
     442,   443,   445,   447,   449,   450,   437,   438,   439,   440,
     459,     0,   460,   462,   463,   464,   278,     0,   275,   282,
     639,     0,   315,     0,   644,     0,    36,     0,    35,    68,
       0,     0,    62,    63,    64,    65,    10,    11,    12,     0,
     154,     0,     0,    96,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,     0,
       0,   297,   319,     0,   108,   109,     0,   103,   105,    54,
       0,   315,   124,     0,   118,     0,   138,   158,   161,   174,
     150,   144,   133,   320,   321,   140,    18,   322,   134,   132,
     125,     0,     0,     0,     0,     0,     0,     0,     0,   568,
      18,    18,   605,   608,     0,     0,     0,     0,    18,     0,
      18,     0,   627,   626,   576,     0,   546,     0,     0,   566,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   570,     0,   571,     0,   603,     0,     0,
       0,     0,     0,     0,     0,   582,   583,     0,     0,     0,
     610,     0,     0,   606,   125,   654,   651,     0,   656,     0,
       0,   784,   785,   125,     0,     0,   846,    21,   848,     0,
     843,   847,   423,   838,    94,    86,    88,    89,    83,    92,
      25,    24,    93,   177,     0,    72,   188,     0,   222,   248,
     247,   246,   231,   238,   232,   230,   237,   544,    31,     0,
       0,   770,   779,     0,   777,   774,     0,     0,   772,     0,
      32,     0,    32,     0,     0,     0,    26,    27,     0,     0,
     405,   397,   423,   475,     0,     0,   423,   423,   423,   452,
     423,   473,   423,     0,     0,   423,   423,   423,   423,   339,
     334,   423,   376,   383,     0,     0,   392,   423,    44,   642,
     641,   643,   645,     6,    42,     8,    61,   110,   165,    97,
      99,   314,   313,   315,   423,   107,   106,   324,   317,     0,
     327,     0,   172,   159,     0,   154,     0,   149,   135,   514,
     514,     0,   513,   507,     0,     0,     0,    18,     0,   625,
       0,   618,   617,     0,     0,   549,     0,   607,   611,   612,
     613,     0,   601,     0,   591,    22,     0,   547,   548,   564,
       0,   572,     0,     0,   595,     0,   578,   577,   590,   589,
     584,     0,     0,   604,   587,   579,   580,   581,   609,   623,
     586,   585,   624,   588,   615,     0,   614,     0,   315,     0,
       0,     0,   638,   629,   632,     0,   653,   753,    18,     0,
      18,   671,     0,     0,   673,   663,    18,   659,     0,   677,
     754,   783,   795,    18,     0,   794,   787,     0,   836,   837,
     845,    21,    18,     0,   844,     0,   479,     0,   480,   481,
       0,   423,   477,   478,   476,   423,   423,    18,   859,     0,
       0,   423,   854,   857,     0,    90,   179,   190,   765,   764,
     778,   773,   775,   776,     0,   766,     0,   768,   831,   832,
       0,     0,   401,   487,     0,   467,     0,     0,     0,     0,
       0,   423,   419,   423,     0,     0,   346,     0,     0,     0,
       0,     0,     0,     0,   316,     0,   423,   330,     0,   323,
       0,   155,   156,   160,   162,   147,   145,   146,   148,   154,
     508,   532,   509,   536,   510,   512,     0,   596,     0,     0,
       0,   619,   598,     0,     0,   553,     0,     0,     0,     0,
       0,   551,   599,   600,   602,   567,   565,   594,   593,   573,
     592,   569,   616,   630,   631,   633,   634,     0,   637,   154,
     676,   664,     0,     0,    18,     0,   662,     0,     0,   680,
     675,   679,     0,     0,   669,   661,     0,   687,   154,   791,
     788,   790,   793,   840,   842,   841,   423,   423,   423,   423,
       0,     0,     0,     0,     0,     0,   499,   482,   484,     0,
      84,   767,   769,   261,   261,     0,   472,   470,   471,   469,
     423,     0,     0,   355,     0,   423,   353,   423,   349,     0,
     423,   347,   423,   423,     0,   461,   325,   331,   318,     0,
     157,   163,   532,   530,   515,     0,     0,   539,     0,   621,
     620,   622,     0,     0,   557,   555,   556,   559,   558,   560,
     550,     0,    18,   756,   760,   666,   667,   665,   668,   741,
     701,   681,   741,   670,   755,   688,   828,     0,     0,     0,
       0,     0,   493,   423,   393,   855,   423,   423,     0,   423,
     498,     0,     0,   468,     0,   420,   421,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   390,     0,
     515,     0,   535,   537,   538,     0,   541,   597,   561,   554,
     552,   635,   754,   758,   762,     0,     0,     0,   690,   826,
     796,   789,   492,   424,   496,     0,   423,   490,   332,     0,
       0,     0,     0,     0,     0,     0,     0,   485,   263,   264,
     474,   370,   354,   352,     0,   423,   350,   368,   348,     0,
     423,   366,   423,   364,   363,   423,   361,     0,   534,     0,
      18,     0,     0,     0,     0,     0,     0,   533,   523,   194,
     198,     0,   540,    18,   543,   757,     0,   672,   744,   742,
     745,    18,     0,    18,   678,     0,   674,     0,     0,     0,
       0,     0,     0,   686,   700,     0,     0,   830,     0,     0,
     423,   423,   341,   345,   343,   423,   500,   344,   380,   377,
     378,   379,   384,     0,   495,   494,   423,   423,   423,   423,
     501,     0,     0,     0,     0,     0,     0,     0,   116,   199,
     521,   195,     0,     0,     0,   516,   520,   524,     0,   525,
       0,   522,   200,   531,   542,     0,     0,     0,    18,     0,
       0,     0,     0,    18,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   761,   740,
       0,   746,     0,     0,   684,   685,   683,   682,   694,   697,
     698,   699,   692,   691,     0,     0,   695,   689,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   829,   821,     0,   497,
     333,   491,   395,   346,     0,   423,     0,     0,     0,     0,
       0,   369,   351,   367,   423,   365,   423,   362,     0,     0,
       0,     0,     0,   526,   527,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   706,   748,   738,     0,     0,     0,
       0,     0,   733,   727,   728,   729,    18,   739,     0,   722,
     702,   705,   703,     0,   720,     0,   707,   709,   710,   711,
     712,   713,   714,   715,   716,    18,    18,   704,     0,    18,
     759,   747,   743,   693,   696,   802,    18,    18,     0,   797,
     800,   801,   819,     0,     0,     0,   814,   822,   825,   824,
     823,   820,    18,     0,   799,   798,     0,     0,    18,   803,
      18,    18,   827,   342,   423,   381,   394,   385,     0,     0,
       0,     0,     0,     0,   193,   195,   517,   518,   519,   528,
     529,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   197,   723,     0,   731,   730,   732,   166,   167,
     734,   735,     0,   736,    18,   719,   708,   718,   721,   724,
     717,   818,   807,   809,   812,   815,   813,     0,   816,   811,
     808,   810,   804,   805,   806,     0,   505,   503,   504,   502,
     356,   423,   196,   200,   200,   200,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   200,     0,     0,     0,
       0,   726,   750,   749,   737,   725,   817,     0,   207,   205,
     206,   208,   200,   200,   200,   200,   751,     0,   423,   201,
     202,   203,   204,   752,     0,   371
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1523, -1523, -1523, -1523,   -76,  -213,  -236,  -277,  -926,  -152,
    -751, -1523, -1137,   -84,  -394,   104, -1523, -1523, -1523, -1523,
    1418,  1084, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523,   510,  1591, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,  -310, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523,  1735,  -101,  1722, -1523,   134,  -257, -1523,
   -1523, -1523, -1523,   865,  -592,   634, -1523, -1523,   315, -1523,
   -1523, -1523, -1523,   -50, -1523,   959,   263, -1523,   957,  -812,
     190, -1522, -1523,  -352, -1523, -1523, -1523, -1523, -1523,  -126,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
    -178, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1098,  1629, -1523, -1523, -1523,
   -1523,  -841,   906,   730,  1427,  -706,  -369, -1523,  1102, -1523,
   -1523, -1336, -1523,   444,  -189,  1189,   332, -1042, -1369,  1830,
   -1270, -1234,  1192,   336, -1523, -1523,  -179,  1190, -1523, -1523,
   -1523, -1523,  -391,   760, -1523, -1523,  -997, -1523,  -165,   796,
     -17, -1523, -1523,   574,   964,   671, -1000, -1523, -1523, -1523,
   -1523,   907,   564, -1523, -1523, -1523,   635, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1079, -1523, -1523,   618, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,   604, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,   556, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1029, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1164
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    91,   562,   571,   563,   400,   956,  1021,
    1022,   793,  1803,   210,  1039,   365,    92,   550,   211,   553,
     542,   543,    93,   219,   220,    94,    95,    21,    22,    23,
      24,    25,    26,   138,   363,    96,  1235,   346,    97,   352,
     347,    98,   582,    99,   585,   908,   100,   575,   101,   102,
     593,   103,   104,   235,   263,   609,  1117,   922,   598,   105,
     917,  1283,  1114,   918,  1401,  1402,   880,   881,  1722,   106,
     107,   602,   264,   357,   728,   729,   373,   741,   742,  1538,
    1698,  1539,  1540,  1712,  1807,    27,    28,    29,    30,   394,
      31,    32,    33,   385,   769,    34,   382,   754,    35,   386,
     375,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   202,   545,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   132,   379,   108,   583,   109,
     898,   899,   900,  1109,   924,   925,   610,   911,   902,   110,
     588,  1275,  1276,  1497,   191,   446,  1578,   825,   447,   826,
     448,   449,   450,  1582,   451,  1583,   192,   453,   454,  1499,
     416,   193,   417,   426,   194,   195,   196,  1230,   197,   515,
    1266,  1231,  1368,  1369,   805,   806,  1277,   111,  1124,   930,
     112,  1289,  1472,  1541,  1611,  1471,  1404,  1290,  1292,  1407,
    1476,  1544,  1294,    58,   113,   642,  1136,  1310,  1311,   114,
     115,  1185,   994,   116,    59,   547,   117,   118,   320,   321,
     322,   999,  1198,  1337,  1342,  1340,  1341,  1486,  1555,  1199,
    1488,  1565,  1200,  1640,  1485,  1549,  1550,  1643,  1814,  1887,
    1873,  1329,  1347,  1424,  1482,  1546,  1484,  1330,    60,    61,
      62,    63,    64,    65,    66,    67,   782,   119,   120,   121,
    1207,  1003,   122,  1348,  1567,  1678,  1771,  1566,  1490,  1349,
      68,    69,   123,   124,   335,  1010,  1011,   336,  1233,  1012,
     706,    70,   125,    71,   126,   127,   128,   516
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     198,   445,   678,   230,   418,   641,   644,   401,   402,   572,
     919,   452,  1232,   308,  1035,  1229,   770,   319,   601,   327,
     797,  1385,   798,   334,   800,   801,   348,   353,  1076,   957,
     796,  1515,   397,  1265,  1267,  1269,  1270,  1571,   411,   630,
    1390,   424,   412,  1522,   638,  1525,  1572,  1573,  1574,  1080,
     398,   399,   413,   551,  1034,   791,   665,   398,   399,   659,
     398,   399,   554,   940,   913,  1365,   555,  1356,   670,  1108,
     673,   231,   518,   519,   520,   521,   522,   679,   422,  1699,
     682,  1210,   556,   557,   558,   559,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   831,   832,   532,  1767,  -329,
    1405,     1,   708,   380,   710,   957,   233,  1229,  -329,  -329,
    -329,  -329,  1215,   576,  -328,   577,   578,   579,   411,   903,
    1768,  1101,   412,  -328,  -328,  -328,  -328,  1215,   933,   967,
    1579,  1212,   413,   518,   519,   520,   521,   522,   565,   440,
     441,   442,   173,   443,  1216,   570,   570,   523,   524,   525,
     526,   527,   528,   529,   530,   531,  1091,   554,   532,  1216,
    1569,   555,   427,   564,  1718,  1719,   518,   519,   520,   521,
     522,   958,   439,   621,   613,    72,   615,   600,   864,   694,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   139,
     629,   532,   440,   441,   442,  1080,   443,   199,   354,   595,
     518,   519,   520,   521,   522,   640,   200,   355,   576,   808,
     577,   578,   579,  1217,   523,   524,   525,   526,   527,   528,
     529,   530,   531,  1332,  1333,   532,   234,   146,  1217,  1580,
    1756,   370,   554,   768,   554,  1682,   555,   554,   555,   681,
     371,   555,   904,   905,   906,   366,   418,   958,   418,   666,
     418,   418,   556,   557,   558,   559,  1334,   556,   557,   558,
     559,   779,  1213,   780,   781,  1581,   784,   786,   714,   788,
     789,   968,   147,  1699,   554,   622,  1397,  1495,   555,  1229,
     440,   441,   442,  1080,   443,  1353,   733,   381,  1098,   916,
    1649,   560,   159,   936,  1218,  1219,  1220,  1221,  1222,  1223,
    1224,   160,   554,   423,   554,   388,   555,   546,   555,  1218,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,  1579,  1102,  1226,
     388,  1757,   556,   557,   558,   559,  1572,  1573,  1574,  1080,
     914,  1225,   580,  1406,  1226,  1572,  1573,  1574,  1080,  1723,
     204,   941,  1769,  1458,  1720,  1460,   783,   869,  1462,  1786,
    1465,  1467,   518,   519,   520,   521,   522,   398,   399,   951,
     915,   739,  1441,  1282,   205,   388,   523,   524,   525,   526,
     527,   528,   529,   530,   531,  1655,   934,   532,   554,   554,
    1721,   554,   555,   555,   223,   555,  1770,  1040,   935,   938,
    1051,   785,  1053,   224,  1054,  1055,   947,   799,   949,   556,
     557,   558,   559,   804,   554,  1414,   983,   740,   555,   389,
     959,   814,   815,   816,   817,   818,  1580,   971,   206,   207,
     226,  1007,   976,  1008,   978,   920,   982,   827,   984,  1447,
    1650,   987,   988,   989,   809,   552,   992,  1108,  1005,  1386,
    1448,   995,  1020,  1498,   996,  1735,  1229,   414,  1774,  1516,
    1077,   792,  1581,   415,   719,  1575,   425,  1004,  1391,  1576,
    1547,  1523,  1392,  1526,   554,   866,   212,  1556,   555,  1357,
    1871,   561,  1324,  1592,  1134,  1016,  1017,  1018,  1594,  1724,
    1595,   390,   829,  1597,   570,   830,  1315,   566,  1020,   822,
     871,  1415,   586,   823,  1775,   833,   225,   879,   633,  1229,
     907,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,  1057,  1685,  -329,   395,  1686,
    1607,  -329,   581,   643,   616,   567,   568,   414,   921,   603,
    1400,   865,  -328,   415,  1651,   921,  -328,   554,   921,   937,
    1608,   555,   213,   229,   870,   945,   946,  1808,   444,  1809,
    1262,   646,  1551,   604,  1263,   944,   214,   556,   557,   558,
     559,   647,   227,   671,   882,   639,   561,   960,   396,   962,
    1498,  1804,   965,  1229,  1229,   969,   970,   979,   518,   519,
     520,   521,   522,  1725,   672,   398,   399,  1062,   201,   356,
     228,   927,   523,   524,   525,   526,   527,   528,   529,   530,
     531,  1081,  1031,   532,  1090,   980,   981,   998,   634,   221,
     605,   606,   876,   877,   878,   554,  1641,   581,   860,   555,
     607,  1066,   372,  1642,   232,  1184,   222,   834,   554,  1106,
     835,  1014,   555,  1015,   635,   556,   557,   558,   559,   445,
     445,   561,  1019,   561,   358,   237,   561,   361,   556,   557,
     558,   559,  1792,   133,  1793,   452,  1244,  1050,  1246,  1052,
    1609,  1610,   206,   207,  1162,   129,   130,  1718,  1719,  1252,
     391,  1867,  1868,  1869,  1870,  1810,  1564,  1811,   518,   519,
     520,   521,   522,   561,   392,   393,  1298,   359,  1229,   444,
    1118,   131,   523,   524,   525,   526,   527,   528,   529,   530,
     531,   861,   360,   532,  1133,  1135,   518,   519,   520,   521,
     522,   561,  1141,   561,  1143,  1056,   651,   652,   362,  1552,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   655,
     656,   532,  1211,  1240,  1639,  1784,  1241,  1423,   608,  1243,
    1553,   862,  1815,  1816,  1575,   928,   663,   664,   929,   518,
     519,   520,   521,   522,  1677,   554,   863,   364,  1071,   555,
     369,  1111,  1072,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   374,  1067,   532,   556,   557,   558,   559,  1092,
     518,   519,   520,   521,   522,    73,   383,   561,   561,  1174,
     561,   771,   215,  1554,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   749,  1073,   532,  1074,   772,   384,  1877,
     554,   216,  1285,   561,   555,   387,    74,   129,   130,  1041,
     637,   688,   689,   206,   207,    75,  1778,  1105,    76,  1123,
     556,   557,   558,   559,  1383,  1042,  1388,  1020,  1384,    77,
    1389,   530,   531,   131,  1293,   532,  1894,  1764,   208,   388,
    1513,   403,    78,  1502,  1514,  1125,  1126,   554,   404,   209,
    1130,   555,    79,   419,  1286,  1287,  1288,   217,    80,   608,
     376,   377,  1822,   561,   773,  1706,  1335,   556,   557,   558,
     559,  1147,  1148,  1765,   405,  1150,   750,  1152,  1153,   406,
    1155,  1299,   407,  1183,   408,   418,  1161,  1707,    81,  1708,
      82,    83,  1206,   409,  1709,   410,   774,   775,    84,   518,
     519,   520,   521,   522,   776,  1175,   603,  1503,  1504,  1710,
     420,  1186,   421,   523,   524,   525,   526,   527,   528,   529,
     530,   531,  1043,   428,   532,   376,   377,   218,  1518,  1529,
     611,  1530,  1519,   429,    85,    86,   561,  1529,   856,   857,
     777,   430,  1331,   431,  1336,   432,    87,   751,   872,   873,
    1344,   378,   433,  1711,   398,   399,  1006,  1350,   544,  1531,
     142,   143,   752,   548,  1505,   549,  1354,  1531,   569,    88,
    1506,   574,    89,   573,   753,   874,   875,   697,   778,  1343,
    1557,  1363,   518,   519,   520,   521,   522,   605,   606,  1068,
    1023,  1024,   133,   587,  1020,   584,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   589,   169,   532,   170,   171,
     172,   173,   174,   175,   561,   398,   399,  1281,  1430,   591,
     176,   177,   824,   178,   590,   179,   592,   561,   134,  1026,
    1027,  1339,   597,  1089,   594,   804,   135,   136,   137,  1256,
    1257,  1258,  1300,  1259,  1837,  1260,   698,  1532,  1533,  1094,
     857,  1534,  1535,   597,  1271,   596,   238,  1536,   148,   149,
    1273,   239,  1187,   599,   169,  1558,   170,   171,   172,   173,
     174,   175,   597,  1323,  1418,  1419,   150,   699,   176,   177,
     722,   178,   619,   179,  1044,  1325,   700,   614,  1427,  1070,
     617,   151,  1420,  1421,  1326,   140,   141,   144,   145,   161,
     152,   618,   153,   154,   620,   240,   623,   203,  1602,  1603,
    1703,  1704,   624,   180,   625,   608,   626,  1261,  1351,   181,
     518,   519,   520,   521,   522,   627,  1188,  1355,   628,  1045,
     723,   724,  1303,   631,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   725,   726,   532,   727,   241,  1370,  1799,
    1800,   632,  1046,   636,   561,  1559,  1560,  1561,   645,  1562,
    1380,   648,   162,   649,   163,   164,   650,  1047,   653,   155,
    1304,   180,  1805,  1806,   811,   812,  1481,   181,  1856,  1857,
    1858,  1859,  1860,   182,   183,  1451,  1452,   654,  1542,  1444,
     701,   702,   703,   704,  1360,    90,  1048,  1049,  1361,  1362,
     657,   658,   660,   661,  1367,   662,   667,   674,   675,   561,
    1408,   677,   668,   165,   166,   167,   168,   680,  1189,  1537,
     184,   185,   434,   435,   436,   437,   669,  1563,   683,   687,
     367,   368,   676,   684,  1381,   685,  1382,   186,   242,   686,
     187,   182,   183,   691,   690,   188,  1425,  1426,   693,  1428,
     518,   519,   520,   521,   522,   695,   561,  1433,   692,   156,
    1434,   705,   696,   707,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   709,   711,   532,   713,   712,   184,   185,
     434,   435,   436,   437,  1600,   715,   716,   717,  1305,   718,
    1306,  1190,  1307,  1308,   730,   186,  1309,  1614,   187,   732,
    1577,   720,   734,   188,   735,  1644,   721,  1646,   736,   737,
     738,  1605,  1474,  1191,   743,  1192,  1061,   744,   157,   745,
    1193,   747,  1194,  1548,   243,  1548,  1195,  1196,   244,  1438,
     804,  1440,   158,   748,   787,   850,   790,   794,   795,   802,
     169,   803,   170,   171,   172,   173,   174,   175,   807,   813,
     810,  1491,   820,  1454,   176,   177,   532,   178,   819,   179,
     851,  1861,  1862,  1863,  1864,  1865,   821,  1197,   852,   828,
     858,   859,  1716,   853,   854,   855,  1761,  1727,   868,  1729,
     883,   909,   912,   245,   910,   926,   931,   246,   169,   932,
     170,   171,   172,   173,   174,   175,   939,   948,   942,  1069,
     943,   247,   176,   177,  1264,   178,   950,   179,   952,   955,
     953,   518,   519,   520,   521,   522,  1760,   189,  1762,  1500,
    1501,   954,  1367,   961,   190,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   963,  1599,   532,   964,   973,   975,
     518,   519,   520,   521,   522,   966,   972,   180,   570,  1606,
     977,   974,   991,   181,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   985,   986,   532,  1645,  1813,   990,   993,
     997,  1648,  1000,  1652,  1653,   189,  1656,  1796,  1797,  1798,
    1823,  1001,   190,  1002,  1009,  1577,  1013,  1577,  1025,  1028,
    1029,  1878,  1879,  1880,  1030,   180,  1032,  1033,  1037,  1827,
    1828,   181,  1036,  1830,  1881,  1058,  1059,  1038,  1060,  1063,
    1831,  1832,  1064,  1084,  1085,  1075,  1065,   182,   183,  1078,
    1889,  1890,  1891,  1892,  1087,  1096,  1838,  1872,  1113,  1097,
    1714,  1099,  1842,  1103,  1843,  1844,  1104,  1079,  1112,  1116,
    1730,  1731,  1732,  1115,  1734,  1736,  1127,  1129,  1683,  1747,
    1128,  1131,  1132,  1137,   184,   185,  1751,  1138,  1139,  1687,
    1688,  1689,  1690,  1140,  1142,   182,   183,  1144,  1753,  1754,
    1145,   186,  1755,  1149,   187,  1759,  1151,  1154,  1875,   188,
    1156,  1157,  1158,  1159,  1160,  1163,  1164,  1779,  1165,  1166,
     169,  1167,   170,   171,   172,   173,   174,   175,  1168,  1169,
    1234,  1170,   184,   185,   176,   177,  1268,   178,  1171,   179,
    1172,  1173,  1176,  1201,   570,   570,   570,  1208,  1238,   186,
    1801,  1209,   187,  1239,  1242,  1245,  1250,   188,  1247,  1248,
    1249,  1817,  1818,  1819,  1820,  1821,   169,  1272,   170,   171,
     172,   173,   174,   175,  1251,  1254,  1255,  1825,  1278,  1826,
     176,   177,  1279,   178,  1280,   179,  1295,  1296,  1297,  1301,
    1302,  1312,  1829,  1313,  1314,  1327,  1316,  1095,  1317,  1318,
    1319,  1338,  1833,  1320,  1321,  1322,  1328,  1834,  1835,  1836,
    1345,  1346,  1358,  1352,  1371,  1359,  1366,  1839,  1372,  1373,
    1840,  1841,  1374,  1375,  1387,  1393,  1403,   180,  1394,  1396,
    1409,  1399,   169,   181,   170,   171,   172,   173,   174,   175,
    1410,  1411,  1412,  1413,  1422,  1416,   176,   177,  1459,   178,
     169,   179,   170,   171,   172,   173,   174,   175,  1417,  1429,
    1431,  1432,  1437,  1446,   176,   177,  1464,   178,  1215,   179,
    1445,  1435,  1453,   180,  1449,  1457,  1461,  1450,  1463,   181,
    1469,   189,  -488,  1473,  1475,  1477,  1468,  1845,   190,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,   182,   183,  1478,
    1216,   169,  1483,   170,   171,   172,   173,   174,   175,  1479,
    1489,  1493,  1508,  1509,  1511,   176,   177,  1466,   178,  1512,
     179,  1517,  1527,  1570,  1543,  1520,  1591,  1590,  1521,   189,
    1593,  1524,  1568,  1596,   184,   185,   190,  1586,  1587,   180,
    1588,  1589,  1598,   182,   183,   181,  1604,  1601,  1612,  1613,
    1654,   186,   236,  1647,   187,  1657,  1680,   180,  1100,   188,
    1684,   248,  1679,   181,  1694,  1691,   265,  1692,   266,  1217,
     309,  1693,   310,  1695,   323,  1696,   328,  1697,   329,  1700,
     184,   185,  1701,  1529,   169,  1093,   170,   171,   172,   173,
     174,   175,  1702,  1713,  1715,  1705,  1726,   186,   176,   177,
     187,   178,  1717,   179,  1746,   188,  1728,  1733,   180,   182,
     183,  1749,  1750,  1758,   181,   518,   519,   520,   521,   522,
    1748,  1745,  1752,  1763,  1773,  1776,  1772,   182,   183,   523,
     524,   525,   526,   527,   528,   529,   530,   531,  1777,  1794,
     532,  1802,  1780,  1824,  1874,  1781,   184,   185,  1876,  1886,
    1218,  1219,  1220,  1221,  1222,  1223,  1224,  1812,  1850,  1782,
    1795,  1088,  1846,   186,   184,   185,   187,  1847,  1895,   731,
    1848,   188,  1225,  1849,  1853,  1226,  1854,  1851,   182,   183,
    1855,   186,  1866,  1882,   187,  1888,  1883,  1884,  1885,   188,
     867,   180,   518,   519,   520,   521,   522,   181,  1893,   612,
    1284,  1766,  1436,  1236,  1237,  1852,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   184,   185,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   746,  1398,  1274,
     901,   189,   186,  1110,  1681,   187,  1785,  1082,   190,   438,
     188,  1083,  1787,  1507,  1086,  1364,  1253,  1291,  1439,   518,
     519,   520,   521,   522,  1528,  1146,  1487,  1470,  1545,  1480,
    1214,   182,   183,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,     0,   532,     0,  -483,   189,     0,     0,
       0,     0,     0,     0,   190,     0,   518,   519,   520,   521,
     522,     0,     0,     0,     0,     0,     0,     0,   184,   185,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
       0,   532,     0,     0,     0,   186,     0,     0,   187,     0,
       0,     0,     0,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   518,   519,   520,
     521,   522,     0,   189,     0,     0,     0,     0,     0,     0,
     190,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   189,   532,   518,   519,   520,   521,   522,   190,     0,
       0,     0,     0,     0,     0,     0,  1496,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,     0,   532,   518,
     519,   520,   521,   522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   189,     0,   532,     0,     0,     0,     0,   190,
     518,   519,   520,   521,   522,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,     0,   532,   518,   519,   520,   521,
     522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
       0,   532,   518,   519,   520,   521,   522,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   189,     0,   532,     0,     0,
       0,     0,   190,   518,   519,   520,   521,   522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,     0,   532,     0,
       0,     0,  1376,   518,   519,   520,   521,   522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,     0,   532,   518,
     519,   520,   521,   522,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,     0,   532,   518,   519,   520,   521,   522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,  1377,
     532,   518,   519,   520,   521,   522,  1215,     0,     0,     0,
       0,     0,     0,     0,     0,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,     0,   532,   518,   519,   520,
     521,   522,   455,     0,     0,     0,     0,     0,  1216,     0,
       0,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,     0,   532,     0,     0,     0,  1378,   518,   519,   520,
     521,   522,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,     0,   532,   518,   519,   520,   521,   522,     0,     0,
       0,     0,     0,  1379,     0,     0,     0,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,  1217,   532,   456,
     457,     0,     0,     0,     0,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,  1215,  1395,   884,   885,   886,   887,   888,
     889,   890,   891,     0,   892,   893,   894,   895,   896,   897,
       0,     0,  -489,  -489,  -489,     0,   486,     0,     0,     0,
    1455,     0,     0,     0,     0,  1216,  -489,  -489,  -489,  -489,
    -489,   528,   529,   530,   531,     0,     0,   532,  1218,  1219,
    1220,  1221,  1222,  1223,  1224,     0,  1456,   455,     0,     0,
       0,     0,     0,     0,     0,   487,     0,     0,     0,     0,
    1225,     0,     0,  1226,   518,   519,   520,   521,   522,     0,
       0,     0,     0,     0,     0,     0,     0,  1510,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,     0,   532,
       0,     0,  1227,     0,  1217,   884,   885,   886,   887,   888,
     889,   890,   891,  1783,   892,   893,   894,   895,   896,   897,
     488,   489,     0,   490,   491,   492,   493,   494,   495,   496,
       0,     0,     0,     0,   456,   457,     0,     0,     0,  1788,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,     0,  1658,
    1789,     0,   497,   498,   499,   500,   501,   502,   503,   504,
     505,     0,     0,     0,     0,  1218,  1219,  1220,  1221,  1222,
    1223,  1224,     0,  1659,  1660,     0,     0,     0,   506,   507,
    1790,     0,     0,     0,     0,     0,     0,  1225,     0,     0,
    1226,     0,     0,   508,  1661,     0,     0,     0,     0,     0,
       0,     0,  1107,     0,     0,     0,  1791,     0,     0,     0,
     487,   249,     0,   517,   509,   510,   511,   512,   518,   519,
     520,   521,   522,     0,     0,     0,     0,     0,     0,     0,
    1442,   249,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,     0,   532,     0,  1529,     0,  1662,     0,     0,
       0,   251,     0,     0,     0,  1228,  1492,     0,   337,   338,
     339,     0,   340,   341,     0,   342,     0,     0,     0,   343,
    1443,   251,   344,     0,  1663,  1531,     0,     0,     0,     0,
       0,   252,  1494,   513,   514,   253,   254,     0,  1202,   256,
     257,     0,     0,   258,     0,     0,   259,     0,     0,     0,
       0,   252,     0,     0,     0,   253,   254,     0,     0,   256,
     257,     0,  1584,   258,     0,     0,   259,   497,   498,   499,
     500,   501,   502,   503,   504,   505,     0,   249,     0,     0,
       0,     0,   267,     0,   260,     0,     0,     0,  1585,   261,
       0,     0,   268,   506,   507,     0,     0,   269,     0,     0,
       0,     0,     0,   249,   260,     0,     0,     0,   508,   261,
       0,   270,  1664,     0,     0,  1665,  1666,   251,     0,     0,
       0,     0,     0,  1667,     0,     0,     0,     0,     0,   509,
     510,   511,   512,     0,     0,     0,     0,     0,     0,     0,
       0,   311,  -328,   251,     0,     0,     0,   252,     0,     0,
     249,   253,   254,   271,   272,   256,   257,     0,     0,   258,
       0,     0,   259,     0,     0,     0,   273,     0,     0,   274,
     330,   275,     0,   252,  1668,   249,     0,   253,   254,     0,
       0,   256,   257,     0,     0,   258,     0,     0,   259,     0,
     251,     0,   518,   519,   520,   521,   522,     0,   513,   514,
     260,     0,     0,     0,     0,   261,   523,   524,   525,   526,
     527,   528,   529,   530,   531,  1177,     0,   532,     0,   276,
     252,   277,     0,     0,   253,   254,   260,     0,   256,   257,
     278,   261,   258,     0,     0,   259,     0,     0,     0,   249,
       0,     0,  1669,     0,     0,   252,     0,     0,     0,   253,
     254,     0,     0,   256,   257,  1178,     0,   258,  1670,     0,
     259,     0,     0,  1671,  1672,     0,  1673,  1674,   279,  1675,
       0,     0,     0,   260,     0,     0,     0,     0,   261,   251,
       0,     0,     0,     0,     0,  1676,   280,     0,     0,  1615,
       0,     0,   331,   281,   282,     0,   283,     0,   260,   249,
    1203,   284,   285,   261,   286,   287,     0,   288,     0,   252,
     289,   290,   291,   253,   254,   249,  1119,   256,   257,   250,
    1204,   258,   923,     0,   259,   292,   293,     0,     0,     0,
     294,     0,   295,   296,     0,   297,     0,     0,     0,   251,
     298,     0,     0,  1205,   299,   300,   249,   301,   302,     0,
     303,   304,   305,     0,     0,   251,   306,     0,     0,     0,
       0,  1529,   260,   345,     0,     0,     0,   261,     0,   252,
       0,     0,     0,   253,   254,   349,   255,   256,   257,     0,
       0,   258,     0,   608,   259,   252,   251,     0,     0,   253,
     254,  1531,     0,   256,   257,     0,     0,   258,     0,     0,
     259,     0,     0,   312,  1616,     0,     0,     0,   313,   314,
     315,     0,     0,     0,     0,     0,   252,   332,  1617,     0,
     253,   254,   260,     0,   256,   257,     0,   261,   258,     0,
       0,   259,     0,     0,     0,     0,     0,     0,   260,     0,
       0,     0,   316,   261,     0,     0,     0,     0,     0,   317,
       0,     0,     0,     0,   350,  1120,  1121,     0,     0,   307,
       0,     4,     0,     0,     0,     0,     0,     0,     0,   260,
       0,  1179,  1180,  1181,   261,     0,     0,     0,  1618,     0,
       0,  1619,  1620,     0,     0,   318,     5,     6,   755,  1621,
       0,     0,     0,     0,     0,     0,     7,     0,     0,     0,
       0,     0,     0,   398,   399,     0,     0,     0,     0,     0,
       0,   884,   885,   886,   887,   888,   889,   890,   891,     0,
     892,   893,   894,   895,   896,   897,     0,     0,     0,     0,
     756,     0,   333,     0,     0,     0,     0,     0,     0,     0,
    1622,     0,     0,  1623,     0,     0,  1624,   518,   519,   520,
       8,     0,     0,     0,     0,     0,     0,  1182,     0,     0,
       0,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   757,   532,     0,     0,  1625,     0,  1626,     0,  1627,
    1628,  1629,  1630,  1631,  1632,     0,     9,     0,     0,    10,
    1633,    11,     0,  1634,     0,     0,  1635,     0,    12,     0,
      13,     0,   324,   758,     0,    14,    15,    16,  1636,     0,
     759,   760,    17,    18,    19,     0,  1637,     0,     0,     0,
       0,  1122,   761,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   762,
     763,   764,   765,     0,   766,   767,     0,     0,     0,     0,
       0,  1638,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     325,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   262,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   326,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   351,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   608,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    20
};

static const yytype_int16 yycheck[] =
{
      17,   190,   312,    87,   169,   282,   283,   159,   160,   222,
     602,   190,  1012,   114,   765,  1012,   385,   118,   254,   120,
     411,     7,   413,   124,   415,   416,   127,   128,     7,    42,
       7,     7,   158,  1075,  1076,  1077,  1078,     6,    15,   275,
       7,    15,    19,     7,   280,     7,    15,    16,    17,    18,
      18,    19,    29,    45,   760,    30,   122,    18,    19,   295,
      18,    19,    15,    51,   162,  1229,    19,    22,   304,   910,
     306,    88,     8,     9,    10,    11,    12,   313,    28,  1601,
     316,  1007,    35,    36,    37,    38,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    27,    28,    33,   127,     6,
      31,     4,   338,     3,   340,    42,    19,  1104,    15,    16,
      17,    18,    19,    15,     6,    17,    18,    19,    15,    42,
     149,    19,    19,    15,    16,    17,    18,    19,    80,   136,
    1499,   255,    29,     8,     9,    10,    11,    12,   214,    15,
      16,    17,    18,    19,    51,   221,   222,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   862,    15,    33,    51,
    1496,    19,   179,   213,   179,   180,     8,     9,    10,    11,
      12,   184,   189,   181,   258,     0,   260,   253,   547,   331,
      22,    23,    24,    25,    26,    27,    28,    29,    30,     3,
     274,    33,    15,    16,    17,    18,    19,    36,    36,   249,
       8,     9,    10,    11,    12,   281,    45,    45,    15,    28,
      17,    18,    19,   120,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   354,   355,    33,   139,     3,   120,  1499,
     323,    36,    15,   385,    15,  1571,    19,    15,    19,   315,
      45,    19,   165,   166,   167,   141,   411,   184,   413,   315,
     415,   416,    35,    36,    37,    38,   387,    35,    36,    37,
      38,   387,   386,   389,   390,  1499,   392,   393,   344,   395,
     396,   278,   162,  1795,    15,   283,  1276,  1441,    19,  1276,
      15,    16,    17,    18,    19,  1211,   362,   187,   880,   599,
     127,    69,   162,    76,   201,   202,   203,   204,   205,   206,
     207,   162,    15,   253,    15,    19,    19,   203,    19,   201,
     202,   203,   204,   205,   206,   207,   223,  1686,   216,   226,
      19,   414,    35,    36,    37,    38,    15,    16,    17,    18,
     428,   223,   139,   264,   226,    15,    16,    17,    18,   127,
     192,   329,   371,  1385,   359,  1387,    45,   560,  1390,  1685,
    1392,  1393,     8,     9,    10,    11,    12,    18,    19,   636,
     596,   129,  1359,  1114,    19,    19,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   156,   328,    33,    15,    15,
     395,    15,    19,    19,    81,    19,   415,   781,   624,   625,
     784,    45,   786,    19,   788,   789,   632,   414,   634,    35,
      36,    37,    38,   420,    15,   246,   663,   175,    19,   123,
     423,   428,   429,   430,   431,   432,  1686,   653,    19,    20,
      19,   698,   658,   700,   660,    36,   662,   444,   664,    22,
     267,   667,   668,   669,   253,   427,   672,  1278,   695,   425,
      33,   677,   719,  1443,   680,   156,  1443,   424,   362,   425,
     429,   426,  1686,   430,   350,   424,   430,   693,   425,   428,
     428,   425,   429,   425,    15,   549,    68,   428,    19,   424,
     428,   424,  1178,  1515,   427,   711,   712,   713,  1520,   267,
    1522,   195,   429,  1525,   560,   432,   423,    20,   765,   425,
     566,   332,   229,   429,   408,   427,   117,   573,   188,  1496,
     423,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,   792,   426,   424,   145,   429,
     127,   428,   424,   184,   261,    58,    59,   424,   604,    45,
    1281,   548,   424,   430,   371,   611,   428,    15,   614,   322,
     147,    19,   144,   144,   561,   258,   259,   139,   424,   141,
     425,   272,   187,    69,   429,   631,   158,    35,    36,    37,
      38,   282,    86,   265,   581,   423,   424,   643,   195,   645,
    1570,  1708,   648,  1570,  1571,   651,   652,   278,     8,     9,
      10,    11,    12,   371,   286,    18,    19,   429,   427,   427,
     164,   608,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   424,   754,    33,   861,   306,   307,   683,   298,    50,
     126,   127,    39,    40,    41,    15,   375,   424,     3,    19,
     136,   429,   427,   382,    19,   994,    67,   429,    15,   906,
     432,   707,    19,   709,   324,    35,    36,    37,    38,   828,
     829,   424,   718,   424,   134,   427,   424,   137,    35,    36,
      37,    38,  1694,    20,  1696,   834,  1050,   783,  1052,   785,
     267,   268,    19,    20,   974,    19,    20,   179,   180,  1060,
     384,  1808,  1809,  1810,  1811,   139,  1488,   141,     8,     9,
      10,    11,    12,   424,   398,   399,   322,     3,  1685,   424,
     926,    45,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    86,     3,    33,   940,   941,     8,     9,    10,    11,
      12,   424,   948,   424,   950,   791,   286,   287,    67,   354,
      22,    23,    24,    25,    26,    27,    28,    29,    30,   296,
     297,    33,  1009,  1043,  1546,   424,  1046,  1329,   254,  1049,
     375,   126,   379,   380,   424,   611,    86,    87,   614,     8,
       9,    10,    11,    12,  1566,    15,   141,    20,   425,    19,
       3,   913,   429,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    86,   429,    33,    35,    36,    37,    38,   863,
       8,     9,    10,    11,    12,     3,     3,   424,   424,   423,
     424,     3,    43,   428,    22,    23,    24,    25,    26,    27,
      28,    29,    30,     3,   821,    33,   823,    19,     3,  1851,
      15,    62,    81,   424,    19,   269,    34,    19,    20,     3,
      80,   402,   403,    19,    20,    43,   377,   903,    46,   930,
      35,    36,    37,    38,   425,    19,   425,  1114,   429,    57,
     429,    29,    30,    45,  1121,    33,  1888,   359,    44,    19,
     425,     3,    70,   126,   429,   931,   932,    15,     3,    55,
     936,    19,    80,    30,   133,   134,   135,   118,    86,   254,
      19,    20,   259,   424,    86,   117,   354,    35,    36,    37,
      38,   957,   958,   395,     3,   961,    86,   963,   964,     3,
     966,  1127,     3,   994,     3,  1060,   972,   139,   116,   141,
     118,   119,  1003,     3,   146,     3,   118,   119,   126,     8,
       9,    10,    11,    12,   126,   991,    45,   190,   191,   161,
     424,   997,   253,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   116,   424,    33,    19,    20,   188,   425,   138,
      69,   140,   429,   424,   162,   163,   424,   138,   428,   429,
     162,   424,  1188,   424,  1190,   424,   174,   157,    60,    61,
    1196,    45,   424,   205,    18,    19,    20,  1203,    15,   168,
     172,   173,   172,    22,   247,    63,  1212,   168,   423,   197,
     253,   170,   200,   181,   184,    60,    61,   206,   200,   389,
     181,  1227,     8,     9,    10,    11,    12,   126,   127,   429,
     428,   429,    20,   423,  1281,    19,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   139,    13,    33,    15,    16,
      17,    18,    19,    20,   424,    18,    19,    20,  1338,   427,
      27,    28,    29,    30,    19,    32,   427,   424,    56,   428,
     429,  1193,    19,    20,   427,  1062,    64,    65,    66,  1066,
    1067,  1068,  1128,  1070,   259,  1072,   275,   256,   257,   428,
     429,   260,   261,    19,  1081,   323,    73,   266,   144,   145,
    1087,    78,   123,   117,    13,   266,    15,    16,    17,    18,
      19,    20,    19,    20,   338,   339,   162,   306,    27,    28,
      79,    30,   427,    32,   278,  1179,   315,    69,  1334,   429,
     423,   177,   428,   429,  1180,     7,     8,     9,    10,    79,
     186,   423,   188,   189,   427,   122,   327,    19,   258,   259,
     149,   150,   323,   120,    81,   254,   423,   429,  1204,   126,
       8,     9,    10,    11,    12,    20,   187,  1213,   284,   323,
     129,   130,   173,    69,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   142,   143,    33,   145,   164,  1234,   149,
     150,    85,   346,   167,   424,   356,   357,   358,    76,   360,
     429,    76,   142,   270,   144,   145,   277,   361,    87,   255,
     211,   120,   147,   148,   424,   425,  1422,   126,   149,   150,
     151,   152,   153,   190,   191,  1373,  1374,   282,  1475,   427,
     419,   420,   421,   422,  1221,   423,   390,   391,  1225,  1226,
     296,   300,   303,   305,  1231,   310,    87,   423,   427,   424,
    1296,   383,   318,   193,   194,   195,   196,   116,   279,   428,
     227,   228,   229,   230,   231,   232,   316,   428,   117,    86,
     142,   143,   427,   423,  1261,   427,  1263,   244,   255,   427,
     247,   190,   191,   427,   423,   252,  1332,  1333,   323,  1335,
       8,     9,    10,    11,    12,    86,   424,  1343,   427,   345,
    1346,   427,   423,    86,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    76,    79,    33,    85,    81,   227,   228,
     229,   230,   231,   232,  1530,   423,   423,   423,   329,    76,
     331,   352,   333,   334,     3,   244,   337,  1543,   247,     3,
    1499,   423,     3,   252,     3,  1551,   423,  1553,     3,     3,
       3,  1534,  1406,   374,     3,   376,   425,    19,   404,     3,
     381,     3,   383,  1485,   341,  1487,   387,   388,   345,  1356,
    1357,  1358,   418,     3,     3,   210,     3,   182,   182,    14,
      13,    15,    15,    16,    17,    18,    19,    20,    27,    30,
      28,  1437,    15,  1380,    27,    28,    33,    30,    19,    32,
     235,   149,   150,   151,   152,   153,   429,   428,   243,     7,
       3,     3,  1618,   248,   249,   250,  1663,  1623,   423,  1625,
     423,   423,    19,   400,   424,   137,    76,   404,    13,    76,
      15,    16,    17,    18,    19,    20,   423,   308,   423,   425,
     423,   418,    27,    28,    29,    30,   175,    32,   423,    31,
     423,     8,     9,    10,    11,    12,  1662,   424,  1664,  1446,
    1447,   423,  1449,   184,   431,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    76,  1529,    33,    76,   423,   423,
       8,     9,    10,    11,    12,    76,    76,   120,  1534,  1535,
     423,   117,   184,   126,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   423,   423,    33,  1552,  1713,   423,   423,
      69,  1557,    19,  1559,  1560,   424,  1562,  1700,  1701,  1702,
    1726,   423,   431,   423,   275,  1684,   423,  1686,     3,     3,
      19,  1853,  1854,  1855,    15,   120,    19,    19,     3,  1745,
    1746,   126,    19,  1749,  1866,    15,    15,    20,    15,   425,
    1756,  1757,   253,    15,    18,   429,    28,   190,   191,   429,
    1882,  1883,  1884,  1885,   424,    20,  1772,  1814,    28,   423,
    1616,   423,  1778,   423,  1780,  1781,   427,   425,   423,   132,
    1626,  1627,  1628,   429,  1630,  1631,    81,   423,  1575,  1635,
      76,   423,   423,   423,   227,   228,  1642,   423,   423,  1586,
    1587,  1588,  1589,   423,   423,   190,   191,   423,  1654,  1655,
      19,   244,  1658,   423,   247,  1661,   423,   423,  1824,   252,
     423,   423,   423,   423,   423,   423,   423,  1673,   423,   423,
      13,   423,    15,    16,    17,    18,    19,    20,   423,   423,
      69,   423,   227,   228,    27,    28,    29,    30,   423,    32,
     423,   423,   423,   423,  1700,  1701,  1702,   423,     3,   244,
    1706,   423,   247,     3,    15,     3,   184,   252,     3,     3,
       3,  1717,  1718,  1719,  1720,  1721,    13,   429,    15,    16,
      17,    18,    19,    20,   184,    28,    28,  1733,   423,  1735,
      27,    28,   425,    30,   182,    32,   423,   429,   423,   423,
     423,   423,  1748,   423,   423,   190,   423,   425,   423,   423,
     423,   323,  1758,   423,   423,   423,   423,  1763,  1764,  1765,
     423,   392,    22,   423,     3,   424,   423,  1773,     3,    15,
    1776,  1777,    15,    28,   429,   429,   427,   120,    15,   428,
     423,    15,    13,   126,    15,    16,    17,    18,    19,    20,
     423,   423,   340,    69,   280,   336,    27,    28,    29,    30,
      13,    32,    15,    16,    17,    18,    19,    20,   335,   427,
     427,   427,    69,    22,    27,    28,    29,    30,    19,    32,
     423,   427,    28,   120,   429,    29,    29,   423,     7,   126,
     184,   424,   425,    19,   265,   423,   428,  1784,   431,   362,
     363,   364,   365,   366,   367,   368,   369,   190,   191,   193,
      51,    13,   427,    15,    16,    17,    18,    19,    20,   330,
     427,   425,     3,     3,   425,    27,    28,    29,    30,   425,
      32,   425,    15,   225,   262,   424,    29,   423,   425,   424,
      29,   425,   425,     7,   227,   228,   431,   424,   424,   120,
     424,   424,   423,   190,   191,   126,   259,   427,   427,   423,
     282,   244,    97,   423,   247,   423,   428,   120,   425,   252,
       7,   106,   423,   126,   429,   425,   111,   425,   113,   120,
     115,   425,   117,   425,   119,   424,   121,   425,   123,   260,
     227,   228,   260,   138,    13,   423,    15,    16,    17,    18,
      19,    20,   260,   323,   427,   147,   318,   244,    27,    28,
     247,    30,   378,    32,   364,   252,   396,   282,   120,   190,
     191,   362,   423,    76,   126,     8,     9,    10,    11,    12,
     386,   394,   423,   378,   386,    76,   318,   190,   191,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    76,   428,
      33,    20,   411,   397,   377,   413,   227,   228,   377,   372,
     201,   202,   203,   204,   205,   206,   207,   428,   425,   423,
     423,   857,   423,   244,   227,   228,   247,   423,   425,   358,
     423,   252,   223,   423,   423,   226,   423,   429,   190,   191,
     423,   244,   423,   423,   247,   429,   423,   423,   423,   252,
     552,   120,     8,     9,    10,    11,    12,   126,   423,   257,
    1115,  1666,  1348,  1024,  1027,  1795,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   227,   228,    33,    46,    47,
      48,    49,    50,    51,    52,    53,    54,   378,  1278,  1103,
     583,   424,   244,   911,  1570,   247,  1684,   828,   431,   189,
     252,   829,  1686,  1449,   834,  1229,  1062,  1120,  1357,     8,
       9,    10,    11,    12,  1470,   956,  1432,  1402,  1482,  1421,
    1011,   190,   191,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,    -1,   423,   424,    -1,    -1,
      -1,    -1,    -1,    -1,   431,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   227,   228,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,    -1,    -1,    -1,   244,    -1,    -1,   247,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,
      11,    12,    -1,   424,    -1,    -1,    -1,    -1,    -1,    -1,
     431,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,   424,    33,     8,     9,    10,    11,    12,   431,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   427,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   424,    -1,    33,    -1,    -1,    -1,    -1,   431,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   424,    -1,    33,    -1,    -1,
      -1,    -1,   431,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,    -1,
      -1,    -1,   425,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,   425,
      33,     8,     9,    10,    11,    12,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,     8,     9,    10,
      11,    12,     5,    -1,    -1,    -1,    -1,    -1,    51,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,    -1,   425,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,   425,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,   120,    33,    82,
      83,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    19,   425,   208,   209,   210,   211,   212,
     213,   214,   215,    -1,   217,   218,   219,   220,   221,   222,
      -1,    -1,     8,     9,    10,    -1,   139,    -1,    -1,    -1,
     425,    -1,    -1,    -1,    -1,    51,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,   201,   202,
     203,   204,   205,   206,   207,    -1,   425,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,    -1,
     223,    -1,    -1,   226,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
      -1,    -1,   255,    -1,   120,   208,   209,   210,   211,   212,
     213,   214,   215,   425,   217,   218,   219,   220,   221,   222,
     233,   234,    -1,   236,   237,   238,   239,   240,   241,   242,
      -1,    -1,    -1,    -1,    82,    83,    -1,    -1,    -1,   425,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,    -1,    42,
     425,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,    -1,    -1,    -1,   201,   202,   203,   204,   205,
     206,   207,    -1,    66,    67,    -1,    -1,    -1,   311,   312,
     425,    -1,    -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,
     226,    -1,    -1,   326,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   425,    -1,    -1,    -1,   425,    -1,    -1,    -1,
     178,    46,    -1,     3,   347,   348,   349,   350,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     423,    46,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,   138,    -1,   140,    -1,    -1,
      -1,    86,    -1,    -1,    -1,   428,   423,    -1,    73,    74,
      75,    -1,    77,    78,    -1,    80,    -1,    -1,    -1,    84,
     224,    86,    87,    -1,   167,   168,    -1,    -1,    -1,    -1,
      -1,   116,   423,   416,   417,   120,   121,    -1,   123,   124,
     125,    -1,    -1,   128,    -1,    -1,   131,    -1,    -1,    -1,
      -1,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,   124,
     125,    -1,   423,   128,    -1,    -1,   131,   285,   286,   287,
     288,   289,   290,   291,   292,   293,    -1,    46,    -1,    -1,
      -1,    -1,    51,    -1,   169,    -1,    -1,    -1,   423,   174,
      -1,    -1,    61,   311,   312,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    46,   169,    -1,    -1,    -1,   326,   174,
      -1,    80,   255,    -1,    -1,   258,   259,    86,    -1,    -1,
      -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,   347,
     348,   349,   350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,   428,    86,    -1,    -1,    -1,   116,    -1,    -1,
      46,   120,   121,   122,   123,   124,   125,    -1,    -1,   128,
      -1,    -1,   131,    -1,    -1,    -1,   135,    -1,    -1,   138,
      66,   140,    -1,   116,   317,    46,    -1,   120,   121,    -1,
      -1,   124,   125,    -1,    -1,   128,    -1,    -1,   131,    -1,
      86,    -1,     8,     9,    10,    11,    12,    -1,   416,   417,
     169,    -1,    -1,    -1,    -1,   174,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    86,    -1,    33,    -1,   188,
     116,   190,    -1,    -1,   120,   121,   169,    -1,   124,   125,
     199,   174,   128,    -1,    -1,   131,    -1,    -1,    -1,    46,
      -1,    -1,   385,    -1,    -1,   116,    -1,    -1,    -1,   120,
     121,    -1,    -1,   124,   125,   126,    -1,   128,   401,    -1,
     131,    -1,    -1,   406,   407,    -1,   409,   410,   237,   412,
      -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    86,
      -1,    -1,    -1,    -1,    -1,   428,   255,    -1,    -1,    66,
      -1,    -1,   188,   262,   263,    -1,   265,    -1,   169,    46,
     385,   270,   271,   174,   273,   274,    -1,   276,    -1,   116,
     279,   280,   281,   120,   121,    46,   123,   124,   125,    66,
     405,   128,    19,    -1,   131,   294,   295,    -1,    -1,    -1,
     299,    -1,   301,   302,    -1,   304,    -1,    -1,    -1,    86,
     309,    -1,    -1,   428,   313,   314,    46,   316,   317,    -1,
     319,   320,   321,    -1,    -1,    86,   325,    -1,    -1,    -1,
      -1,   138,   169,   428,    -1,    -1,    -1,   174,    -1,   116,
      -1,    -1,    -1,   120,   121,    75,   123,   124,   125,    -1,
      -1,   128,    -1,   254,   131,   116,    86,    -1,    -1,   120,
     121,   168,    -1,   124,   125,    -1,    -1,   128,    -1,    -1,
     131,    -1,    -1,   346,   181,    -1,    -1,    -1,   351,   352,
     353,    -1,    -1,    -1,    -1,    -1,   116,   313,   195,    -1,
     120,   121,   169,    -1,   124,   125,    -1,   174,   128,    -1,
      -1,   131,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,   385,   174,    -1,    -1,    -1,    -1,    -1,   392,
      -1,    -1,    -1,    -1,   154,   262,   263,    -1,    -1,   428,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
      -1,   342,   343,   344,   174,    -1,    -1,    -1,   255,    -1,
      -1,   258,   259,    -1,    -1,   428,    71,    72,     3,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,
      -1,    -1,    -1,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,   208,   209,   210,   211,   212,   213,   214,   215,    -1,
     217,   218,   219,   220,   221,   222,    -1,    -1,    -1,    -1,
      45,    -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,    -1,    -1,   320,    -1,    -1,   323,     8,     9,    10,
     135,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    86,    33,    -1,    -1,   352,    -1,   354,    -1,   356,
     357,   358,   359,   360,   361,    -1,   171,    -1,    -1,   174,
     367,   176,    -1,   370,    -1,    -1,   373,    -1,   183,    -1,
     185,    -1,   333,   118,    -1,   190,   191,   192,   385,    -1,
     125,   126,   197,   198,   199,    -1,   393,    -1,    -1,    -1,
      -1,   428,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   154,
     155,   156,   157,    -1,   159,   160,    -1,    -1,    -1,    -1,
      -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     401,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   254,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   341
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   434,   435,    46,    71,    72,    81,   135,   171,
     174,   176,   183,   185,   190,   191,   192,   197,   198,   199,
     341,   460,   461,   462,   463,   464,   465,   518,   519,   520,
     521,   523,   524,   525,   528,   531,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   626,   637,
     671,   672,   673,   674,   675,   676,   677,   678,   693,   694,
     704,   706,     0,     3,    34,    43,    46,    57,    70,    80,
      86,   116,   118,   119,   126,   162,   163,   174,   197,   200,
     423,   436,   449,   455,   458,   459,   468,   471,   474,   476,
     479,   481,   482,   484,   485,   492,   502,   503,   560,   562,
     572,   610,   613,   627,   632,   633,   636,   639,   640,   680,
     681,   682,   685,   695,   696,   705,   707,   708,   709,    19,
      20,    45,   558,    20,    56,    64,    65,    66,   466,     3,
     558,   558,   172,   173,   558,   558,     3,   162,   144,   145,
     162,   177,   186,   188,   189,   255,   345,   404,   418,   162,
     162,    79,   142,   144,   145,   193,   194,   195,   196,    13,
      15,    16,    17,    18,    19,    20,    27,    28,    30,    32,
     120,   126,   190,   191,   227,   228,   244,   247,   252,   424,
     431,   577,   589,   594,   597,   598,   599,   601,   603,    36,
      45,   427,   547,   558,   192,    19,    19,    20,    44,    55,
     446,   451,    68,   144,   158,    43,    62,   118,   188,   456,
     457,    50,    67,    81,    19,   117,    19,    86,   164,   144,
     446,   603,    19,    19,   139,   486,   486,   427,    73,    78,
     122,   164,   255,   341,   345,   400,   404,   418,   486,    46,
      66,    86,   116,   120,   121,   123,   124,   125,   128,   131,
     169,   174,   428,   487,   505,   486,   486,    51,    61,    66,
      80,   122,   123,   135,   138,   140,   188,   190,   199,   237,
     255,   262,   263,   265,   270,   271,   273,   274,   276,   279,
     280,   281,   294,   295,   299,   301,   302,   304,   309,   313,
     314,   316,   317,   319,   320,   321,   325,   428,   487,   486,
     486,    84,   346,   351,   352,   353,   385,   392,   428,   487,
     641,   642,   643,   486,   333,   401,   428,   487,   486,   486,
      66,   188,   313,   428,   487,   697,   700,    73,    74,    75,
      77,    78,    80,    84,    87,   428,   470,   473,   487,    75,
     154,   428,   472,   487,    36,    45,   427,   506,   466,     3,
       3,   466,    67,   467,    20,   448,   448,   558,   558,     3,
      36,    45,   427,   509,    86,   533,    19,    20,    45,   559,
       3,   187,   529,     3,     3,   526,   532,   269,    19,   123,
     195,   384,   398,   399,   522,   145,   195,   522,    18,    19,
     440,   442,   442,     3,     3,     3,     3,     3,     3,     3,
       3,    15,    19,    29,   424,   430,   593,   595,   601,    30,
     424,   253,    28,   253,    15,   430,   596,   603,   424,   424,
     424,   424,   424,   424,   229,   230,   231,   232,   582,   603,
      15,    16,    17,    19,   424,   577,   578,   581,   583,   584,
     585,   587,   589,   590,   591,     5,    82,    83,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   139,   178,   233,   234,
     236,   237,   238,   239,   240,   241,   242,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   311,   312,   326,   347,
     348,   349,   350,   416,   417,   602,   710,     3,     8,     9,
      10,    11,    12,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    33,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   453,   454,    15,   548,   448,   638,    22,    63,
     450,    45,   427,   452,    15,    19,    35,    36,    37,    38,
      69,   424,   437,   439,   506,   437,    20,    58,    59,   423,
     437,   438,   438,   181,   170,   480,    15,    17,    18,    19,
     139,   424,   475,   561,    19,   477,   509,   423,   573,   139,
      19,   427,   427,   483,   427,   506,   323,    19,   491,   117,
     437,   439,   504,    45,    69,   126,   127,   136,   254,   488,
     569,    69,   488,   446,    69,   446,   509,   423,   423,   427,
     427,   181,   283,   327,   323,    81,   423,    20,   284,   446,
     439,    69,    85,   188,   298,   324,   167,    80,   439,   423,
     437,   440,   628,   184,   440,    76,   272,   282,    76,   270,
     277,   286,   287,    87,   282,   296,   297,   296,   300,   439,
     303,   305,   310,    86,    87,   122,   315,    87,   318,   316,
     439,   265,   286,   439,   423,   427,   427,   383,   475,   439,
     116,   437,   439,   117,   423,   427,   427,    86,   402,   403,
     423,   427,   427,   323,   442,    86,   423,   206,   275,   306,
     315,   419,   420,   421,   422,   427,   703,    86,   439,    76,
     439,    79,    81,    85,   437,   423,   423,   423,    76,   448,
     423,   423,    79,   129,   130,   142,   143,   145,   507,   508,
       3,   467,     3,   437,     3,     3,     3,     3,     3,   129,
     175,   510,   511,     3,    19,     3,   559,     3,     3,     3,
      86,   157,   172,   184,   530,     3,    45,    86,   118,   125,
     126,   137,   154,   155,   156,   157,   159,   160,   442,   527,
     569,     3,    19,    86,   118,   119,   126,   162,   200,   522,
     522,   522,   679,    45,   522,    45,   522,     3,   522,   522,
       3,    30,   426,   444,   182,   182,     7,   595,   595,   603,
     595,   595,    14,    15,   603,   607,   608,    27,    28,   253,
      28,   596,   596,    30,   603,   603,   603,   603,   603,    19,
      15,   429,   425,   429,    29,   580,   582,   603,     7,   429,
     432,    27,    28,   427,   429,   432,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     210,   235,   243,   248,   249,   250,   428,   429,     3,     3,
       3,    86,   126,   141,   569,   603,   446,   453,   423,   438,
     603,   437,    60,    61,    60,    61,    39,    40,    41,   437,
     499,   500,   603,   423,   208,   209,   210,   211,   212,   213,
     214,   215,   217,   218,   219,   220,   221,   222,   563,   564,
     565,   567,   571,    42,   165,   166,   167,   423,   478,   423,
     424,   570,    19,   162,   428,   439,   475,   493,   496,   497,
      36,   437,   490,    19,   567,   568,   137,   603,   490,   490,
     612,    76,    76,    80,   328,   439,    76,   322,   439,   423,
      51,   329,   423,   423,   437,   258,   259,   439,   308,   439,
     175,   440,   423,   423,   423,    31,   441,    42,   184,   423,
     437,   184,   437,    76,    76,   437,    76,   136,   278,   437,
     437,   439,    76,   423,   117,   423,   439,   423,   439,   278,
     306,   307,   439,   491,   439,   423,   423,   439,   439,   439,
     423,   184,   439,   423,   635,   439,   439,    69,   437,   644,
      19,   423,   423,   684,   439,   491,    20,   440,   440,   275,
     698,   699,   702,   423,   437,   437,   439,   439,   439,   437,
     440,   442,   443,   428,   429,     3,   428,   429,     3,    19,
      15,   442,    19,    19,   568,   443,    19,     3,    20,   447,
     447,     3,    19,   116,   278,   323,   346,   361,   390,   391,
     522,   447,   522,   447,   447,   447,   437,   440,    15,    15,
      15,   425,   429,   425,   253,    28,   429,   429,   429,   425,
     429,   425,   429,   603,   603,   429,     7,   429,   429,   425,
      18,   424,   578,   585,    15,    18,   590,   424,   454,    20,
     491,   568,   446,   423,   428,   425,    20,   423,   497,   423,
     425,    19,   216,   423,   427,   437,   440,   425,   564,   566,
     571,   442,   423,    28,   495,   429,   132,   489,   439,   123,
     262,   263,   428,   487,   611,   437,   437,    81,    76,   423,
     437,   423,   423,   439,   427,   439,   629,   423,   423,   423,
     423,   439,   423,   439,   423,    19,   628,   437,   437,   423,
     437,   423,   437,   437,   423,   437,   423,   423,   423,   423,
     423,   437,   475,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   437,   423,    86,   126,   342,
     343,   344,   428,   487,   569,   634,   437,   123,   187,   279,
     352,   374,   376,   381,   383,   387,   388,   428,   645,   652,
     655,   423,   123,   385,   405,   428,   487,   683,   423,   423,
     441,   440,   255,   386,   698,    19,    51,   120,   201,   202,
     203,   204,   205,   206,   207,   223,   226,   255,   428,   599,
     600,   604,   609,   701,    69,   469,   508,   511,     3,     3,
     475,   475,    15,   475,   447,     3,   447,     3,     3,     3,
     184,   184,   595,   607,    28,    28,   603,   603,   603,   603,
     603,   429,   425,   429,    29,   580,   603,   580,    29,   580,
     580,   603,   429,   603,   565,   574,   575,   609,   423,   425,
     182,    20,   443,   494,   496,    81,   133,   134,   135,   614,
     620,   614,   621,   440,   625,   423,   429,   423,   322,   439,
     437,   423,   423,   173,   211,   329,   331,   333,   334,   337,
     630,   631,   423,   423,   423,   423,   423,   423,   423,   423,
     423,   423,   423,    20,   568,   446,   437,   190,   423,   664,
     670,   439,   354,   355,   387,   354,   439,   646,   323,   442,
     648,   649,   647,   389,   439,   423,   392,   665,   686,   692,
     439,   437,   423,   441,   439,   437,    22,   424,    22,   424,
     603,   603,   603,   439,   602,   710,   423,   603,   605,   606,
     437,     3,     3,    15,    15,    28,   425,   425,   425,   425,
     429,   603,   603,   425,   429,     7,   425,   429,   425,   429,
       7,   425,   429,   429,    15,   425,   428,   609,   566,    15,
     443,   497,   498,   427,   619,    31,   264,   622,   437,   423,
     423,   423,   340,    69,   246,   332,   336,   335,   338,   339,
     428,   429,   280,   497,   666,   437,   437,   439,   437,   427,
     475,   427,   427,   437,   437,   427,   498,    69,   603,   608,
     603,   599,   423,   224,   427,   423,    22,    22,    33,   429,
     423,   533,   533,    28,   603,   425,   425,    29,   580,    29,
     580,    29,   580,     7,    29,   580,    29,   580,   428,   184,
     619,   618,   615,    19,   446,   265,   623,   423,   193,   330,
     631,   439,   667,   427,   669,   657,   650,   657,   653,   427,
     691,   437,   423,   425,   423,   710,   427,   576,   609,   592,
     603,   603,   126,   190,   191,   247,   253,   606,     3,     3,
     425,   425,   425,   425,   429,     7,   425,   425,   425,   429,
     424,   425,     7,   425,   425,     7,   425,    15,   615,   138,
     140,   168,   256,   257,   260,   261,   266,   428,   512,   514,
     515,   616,   440,   262,   624,   665,   668,   428,   442,   658,
     659,   187,   354,   375,   428,   651,   428,   181,   266,   356,
     357,   358,   360,   428,   512,   654,   690,   687,   425,   574,
     225,     6,    15,    16,    17,   424,   428,   577,   579,   581,
     583,   584,   586,   588,   423,   423,   424,   424,   424,   424,
     423,    29,   580,    29,   580,   580,     7,   580,   423,   446,
     439,   427,   258,   259,   259,   438,   437,   127,   147,   267,
     268,   617,   427,   423,   439,    66,   181,   195,   255,   258,
     259,   266,   317,   320,   323,   352,   354,   356,   357,   358,
     359,   360,   361,   367,   370,   373,   385,   393,   428,   512,
     656,   375,   382,   660,   439,   437,   439,   423,   437,   127,
     267,   371,   437,   437,   282,   156,   437,   423,    42,    66,
      67,    87,   140,   167,   255,   258,   259,   266,   317,   385,
     401,   406,   407,   409,   410,   412,   428,   512,   688,   423,
     428,   576,   574,   603,     7,   426,   429,   603,   603,   603,
     603,   425,   425,   425,   429,   425,   424,   425,   513,   514,
     260,   260,   260,   149,   150,   147,   117,   139,   141,   146,
     161,   205,   516,   323,   437,   427,   439,   378,   179,   180,
     359,   395,   501,   127,   267,   371,   318,   439,   396,   439,
     437,   437,   437,   282,   437,   156,   437,   362,   363,   364,
     365,   366,   367,   368,   369,   394,   364,   437,   386,   362,
     423,   437,   423,   437,   437,   437,   323,   414,    76,   437,
     439,   440,   439,   378,   359,   395,   501,   127,   149,   371,
     415,   689,   318,   386,   362,   408,    76,    76,   377,   437,
     411,   413,   423,   425,   424,   579,   574,   586,   425,   425,
     425,   425,   580,   580,   428,   423,   438,   438,   438,   149,
     150,   437,    20,   445,   445,   147,   148,   517,   139,   141,
     139,   141,   428,   439,   661,   379,   380,   437,   437,   437,
     437,   437,   259,   439,   397,   437,   437,   439,   439,   437,
     439,   439,   439,   437,   437,   437,   437,   259,   439,   437,
     437,   437,   439,   439,   439,   603,   423,   423,   423,   423,
     425,   429,   513,   423,   423,   423,   149,   150,   151,   152,
     153,   149,   150,   151,   152,   153,   423,   445,   445,   445,
     445,   428,   440,   663,   377,   439,   377,   580,   516,   516,
     516,   516,   423,   423,   423,   423,   372,   662,   429,   516,
     516,   516,   516,   423,   580,   425
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   433,   434,   434,   435,   435,   436,   437,   437,   437,
     438,   438,   438,   439,   439,   439,   439,   439,   439,   440,
     440,   441,   441,   442,   443,   443,   444,   444,   445,   446,
     446,   447,   447,   448,   448,   449,   450,   450,   451,   451,
     451,   452,   452,   453,   453,   454,   454,   454,   454,   454,
     454,   454,   454,   454,   455,   455,   456,   456,   456,   456,
     457,   457,   457,   457,   457,   457,   458,   459,   459,   459,
     459,   460,   461,   462,   463,   464,   465,   466,   466,   467,
     467,   467,   468,   469,   469,   470,   470,   470,   470,   470,
     470,   471,   472,   472,   473,   473,   474,   474,   475,   475,
     475,   475,   475,   476,   477,   477,   478,   478,   478,   478,
     479,   480,   480,   481,   482,   483,   483,   484,   484,   485,
     485,   486,   486,   486,   486,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     488,   488,   488,   488,   489,   489,   489,   489,   489,   490,
     490,   491,   492,   492,   493,   494,   494,   494,   495,   495,
     496,   497,   497,   498,   499,   500,   501,   501,   502,   503,
     503,   503,   503,   504,   505,   506,   506,   506,   507,   507,
     508,   508,   508,   508,   508,   508,   509,   509,   509,   510,
     510,   511,   511,   512,   512,   513,   513,   514,   514,   515,
     516,   516,   516,   516,   516,   516,   516,   516,   516,   517,
     517,   517,   517,   517,   517,   517,   517,   517,   517,   518,
     519,   520,   521,   522,   522,   523,   524,   525,   526,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   527,   527,   527,   528,   529,   529,   529,   529,   530,
     530,   530,   531,   532,   532,   532,   532,   532,   532,   532,
     532,   533,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   547,   547,   548,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   558,   558,   559,   559,   559,   561,   560,   562,   563,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   564,   565,   565,   566,   566,   567,
     568,   568,   569,   570,   570,   571,   573,   572,   574,   574,
     575,   575,   576,   576,   577,   578,   578,   578,   578,   578,
     578,   579,   579,   579,   579,   579,   580,   581,   581,   581,
     581,   581,   581,   581,   581,   581,   581,   582,   582,   582,
     582,   583,   583,   583,   584,   584,   584,   584,   584,   584,
     584,   584,   585,   585,   585,   585,   585,   586,   586,   586,
     586,   586,   587,   587,   588,   588,   589,   590,   590,   590,
     590,   591,   591,   592,   592,   592,   593,   593,   594,   594,
     595,   595,   595,   595,   595,   595,   596,   596,   596,   597,
     597,   597,   597,   597,   597,   597,   597,   597,   597,   598,
     598,   598,   598,   599,   600,   601,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   603,   603,   603,   603,
     603,   603,   603,   603,   603,   603,   604,   604,   604,   604,
     604,   604,   605,   606,   606,   606,   607,   607,   608,   608,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   609,   610,   611,   611,   611,
     611,   612,   612,   613,   614,   615,   616,   616,   616,   616,
     616,   616,   616,   616,   617,   617,   617,   617,   617,   617,
     618,   618,   619,   619,   620,   621,   622,   622,   622,   623,
     623,   624,   624,   625,   626,   627,   628,   628,   628,   629,
     629,   630,   630,   631,   631,   631,   631,   631,   631,   631,
     631,   631,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   633,   634,
     634,   634,   634,   634,   634,   634,   635,   635,   636,   637,
     638,   638,   638,   638,   638,   638,   639,   640,   640,   641,
     641,   641,   641,   641,   641,   641,   641,   641,   642,   643,
     644,   644,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   646,   645,   647,   645,   645,   645,   645,   648,   648,
     649,   650,   650,   651,   651,   651,   652,   652,   653,   653,
     654,   654,   654,   654,   654,   654,   654,   654,   654,   654,
     654,   655,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   656,
     656,   657,   657,   658,   659,   660,   660,   660,   661,   661,
     662,   662,   663,   664,   665,   665,   667,   666,   668,   668,
     669,   669,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   679,   679,   679,   679,   679,   679,   679,   679,
     680,   681,   681,   681,   681,   681,   682,   683,   683,   683,
     683,   683,   684,   684,   685,   686,   687,   688,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   689,   689,   689,   689,   690,   690,   691,   691,
     692,   693,   694,   695,   696,   696,   696,   696,   696,   697,
     698,   698,   698,   699,   699,   700,   700,   700,   700,   700,
     700,   700,   700,   700,   701,   701,   702,   702,   703,   703,
     704,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   707,   707,   707,
     707,   707,   707,   707,   707,   707,   707,   708,   708,   708,
     708,   709,   709,   709,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710,   710,   710,   710,   710,   710,   710,
     710,   710,   710,   710
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     4,     5,     3,     3,     4,     2,     0,     1,     0,
       1,     2,     2,     0,     2,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     3,     2,     4,     5,     1,     3,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     2,     3,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     4,     2,     2,     3,     2,
       2,     1,     1,     1,     0,     2,     2,     2,     2,     2,
       1,     1,     3,     3,     0,     1,     1,     2,     0,     1,
       3,     1,     3,     1,     0,     2,     2,     2,     2,     3,
       3,     3,     5,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     4,     4,     4,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     1,     4,     0,     3,     3,     3,     0,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     9,     9,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     4,     4,     4,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     5,     7,     5,
       7,     9,     7,     5,     7,     5,    11,     1,     1,     2,
       1,     7,     9,     7,     7,     9,     7,     9,     7,     9,
       7,    15,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     4,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     8,     2,     1,     2,     2,
       2,     0,     3,     5,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     5,     2,     0,     3,     3,     1,
       3,     1,     3,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     5,     6,     4,     6,     4,     6,
       4,     4,     5,     6,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     6,     5,     6,     8,     6,     6,
       6,     5,     6,     4,     5,     4,     4,     5,     4,     5,
       4,     5,     5,     5,     5,     5,     6,     5,     5,     6,
       7,     7,     7,     5,     5,     5,     4,     4,     2,     1,
       2,     2,     1,     2,     2,     4,     0,     3,     5,     4,
       0,     3,     3,     3,     2,     3,     2,     3,     3,     1,
       2,     3,     2,     4,     3,     2,     3,     1,     2,     4,
       0,     3,     2,     1,     2,     3,     3,     3,     3,     2,
       3,     0,     5,     0,     5,     2,     2,     1,     4,     1,
       1,     0,     3,     2,     2,     2,     5,     2,     0,     3,
       0,     2,     2,     3,     2,     2,     3,     2,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     3,     2,     3,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     4,     6,     6,     6,     7,     6,     7,
       5,     0,     2,     3,     2,     3,     3,     2,     3,     2,
       2,     3,     3,     5,     4,     4,     2,     1,     2,     4,
       2,     2,     0,     3,     5,     0,     0,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     4,     3,     2,
       2,     1,     1,     1,     1,     1,     0,     3,     0,     3,
       4,     6,     6,     2,     3,     3,     5,     5,     4,     2,
       3,     3,     3,     1,     2,     4,     3,     3,     3,     2,
       2,     2,     2,     2,     1,     3,     0,     2,     0,     3,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       1,     2,     1,     2,     2,     1,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 841 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 842 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 855 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 865 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 866 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4145 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 873 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 4151 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 874 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 4157 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 875 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 4163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 883 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 4169 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 884 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4175 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 885 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4181 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4187 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 887 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 888 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4199 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 895 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 4208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 902 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 4214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 903 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 907 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 4229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 915 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 4235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 919 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 923 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 4253 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 930 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 4263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 939 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 4272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 947 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 951 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 952 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 958 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 4301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 967 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 968 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 4313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 972 "cf-parse.y" /* yacc.c:1646  */
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = rf_file(f);
   }
#line 4323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 977 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 978 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 4335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 982 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 983 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 987 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 988 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 992 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 993 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 4371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 994 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 4377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 995 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 996 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 997 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 998 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 999 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1000 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 1006 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1007 "cf-parse.y" /* yacc.c:1646  */
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = rf_fileno(f);
   }
#line 4429 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1017 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4435 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4441 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1019 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4447 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4453 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1023 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4459 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1024 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4465 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1025 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4471 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1026 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4477 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1027 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4483 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1028 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4489 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1038 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4495 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1039 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4501 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1040 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4507 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1041 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4513 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1050 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4519 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1053 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1060 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1063 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1066 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1069 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1072 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1077 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4561 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4567 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4573 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1087 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1092 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 4585 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1093 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1097 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1098 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1102 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 4618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1109 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4624 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1110 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4630 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1111 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 4642 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1123 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4657 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1132 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1146 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 4675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1147 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 4681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1161 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1162 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1166 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1167 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1169 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1176 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 4732 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1198 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4738 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1199 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4744 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1200 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4750 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1201 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4756 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1206 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4762 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1212 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4768 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1213 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4774 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1217 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4784 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1225 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4792 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1231 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1245 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1246 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1250 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1256 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1260 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1269 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1280 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1284 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1285 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1286 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1287 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1288 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1289 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1290 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1291 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4915 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1292 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1293 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->vrf = if_get_by_name((yyvsp[0].t)); }
#line 4927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1294 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1295 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1296 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1300 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1302 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1307 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1308 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1309 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1310 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4987 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1311 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1315 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 5004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1321 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 5010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1325 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 5019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1333 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 5025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1334 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 5031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1342 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 5041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1350 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 5047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1352 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1356 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 5065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1357 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 5071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1371 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 5077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1373 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 5087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1385 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 5093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1386 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 5099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1392 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 5108 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1402 "cf-parse.y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 5114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1406 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 5124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1420 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1421 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1422 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1427 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1431 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 5154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1432 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 5160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1433 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 5166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1434 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 5172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1435 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 5178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1436 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 5184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1442 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1443 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1444 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1449 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1453 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 5214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1454 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 5220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1475 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 5242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1495 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 5248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1496 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 5254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1497 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 5260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1498 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 5266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1499 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 5272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1500 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 5278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1501 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 5284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1502 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 5290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1503 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 5296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1507 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_MD5; }
#line 5302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1508 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA1; }
#line 5308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1509 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA256; }
#line 5314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1510 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA384; }
#line 5320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1511 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA512; }
#line 5326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1512 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 5332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1513 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 5338 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1514 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 5344 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1515 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 5350 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1516 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 5356 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1523 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 5362 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1526 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 5368 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1529 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 5374 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1532 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 5380 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1536 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5386 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1540 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 5392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1543 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 5398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1547 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 5404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1550 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5414 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1555 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1561 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1568 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5447 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1573 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1578 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1583 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1587 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5485 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1591 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1595 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1604 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5521 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1612 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1616 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5539 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1623 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1624 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5551 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1625 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5557 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1631 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 5563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1634 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1641 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1648 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1652 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1660 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5612 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1661 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1662 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5624 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1668 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5630 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1671 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5638 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1674 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5644 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1675 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5650 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1676 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5656 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1677 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1678 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1679 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1680 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1685 "cf-parse.y" /* yacc.c:1646  */
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5690 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1690 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5700 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1699 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1706 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1713 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1721 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1723 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1725 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1727 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1729 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1731 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1733 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1735 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1738 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1741 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1747 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1748 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1749 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1753 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1754 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1761 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1763 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1765 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 5841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1767 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1769 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1771 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1775 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1779 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1782 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1785 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1786 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1787 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1791 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1792 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1793 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1801 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1802 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5930 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1811 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5936 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1815 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5942 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1816 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1817 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5954 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1818 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5960 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1819 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1820 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1821 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5978 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1822 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LC; }
#line 5984 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1823 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5990 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1824 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1825 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 6002 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1826 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 6008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 6014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1828 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LCLIST; }
#line 6020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1829 "cf-parse.y" /* yacc.c:1646  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 6044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1851 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 6057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1862 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 6063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1863 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 6078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1871 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1878 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 6098 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1887 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 6107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1895 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 6130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1916 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 6136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1917 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 6142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1921 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 6156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1933 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 6165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1936 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name);
     cf_pop_scope();
   }
#line 6176 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6182 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1950 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 6188 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1953 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 6194 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1954 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 6200 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1958 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 6208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1961 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 6216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1970 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 6222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1983 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1984 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1985 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1986 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1987 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1991 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 6265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1999 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6271 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2000 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 6277 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2001 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6283 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2002 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6289 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2003 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6295 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2007 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 6301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2010 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2011 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2012 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6319 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2013 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6325 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2014 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2015 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2016 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2017 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 6355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 6361 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 6367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2025 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 6373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 6385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2031 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2032 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2033 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2038 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6415 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2039 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6421 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2040 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6427 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2042 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6439 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6445 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6451 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2052 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2060 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2061 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2066 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2071 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2075 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2082 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2083 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2084 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2085 "cf-parse.y" /* yacc.c:1646  */
    {
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2092 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2093 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2096 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2097 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6553 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2104 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2117 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2121 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2122 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2126 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2127 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6601 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2128 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6607 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2129 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2130 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2131 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6625 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2135 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2136 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2137 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2141 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2143 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2144 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2145 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2146 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2147 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2148 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2149 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2150 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2154 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2155 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2156 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_lc((yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2157 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_path_mask((yyvsp[0].h)); }
#line 6727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2171 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2193 "cf-parse.y" /* yacc.c:1646  */
    {
     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2205 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
#line 6772 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2206 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
#line 6778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2207 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_PREFIX,     SA_NET,	0); }
#line 6784 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2208 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
#line 6790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2209 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
#line 6796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2210 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
#line 6802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2211 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTC,   SA_CAST,	0); }
#line 6808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2212 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
#line 6814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2213 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	1); }
#line 6820 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2214 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
#line 6826 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2218 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6832 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2219 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6838 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2220 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2221 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2222 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2223 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2224 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2225 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2226 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2227 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2230 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2232 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2233 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[0].x); }
#line 6922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2234 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2236 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2237 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2238 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 6952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2242 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 6958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2244 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[0].fda)); }
#line 6964 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2246 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6970 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2247 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6976 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2248 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6982 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2249 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2250 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6994 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7000 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2261 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
#line 7006 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2262 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
#line 7012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2263 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
#line 7018 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2264 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
#line 7024 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2265 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7030 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2266 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 7036 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2267 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 7042 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2268 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 7048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2270 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 7054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2271 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2274 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 7084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2296 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 7090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2297 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 7096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2298 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 7102 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2299 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 7108 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2300 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 7114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2301 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 7120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2305 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 7126 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2308 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7132 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2309 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2310 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 7149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2318 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 7160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2324 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 7171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2332 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2333 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2337 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7193 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2342 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7206 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2350 "cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 7219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2358 "cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7229 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2363 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-3].fda));
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2367 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[-3].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2373 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2377 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-2].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
#line 7268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2382 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 7274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2383 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2384 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 7290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2391 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 7296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2392 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2393 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2394 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2395 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2402 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 7334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2429 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 7351 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2443 "cf-parse.y" /* yacc.c:1646  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 7374 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2463 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7380 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2464 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 7386 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2465 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2466 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 7398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2467 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 7404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2468 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 7410 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2469 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 7416 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2470 "cf-parse.y" /* yacc.c:1646  */
    {}
#line 7422 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2474 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 7428 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2475 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 7434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2476 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 7440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2477 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 7446 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2478 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 7452 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2479 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 7458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2497 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 7464 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2501 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 7470 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2502 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 7476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2503 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 7482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2507 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 7488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2508 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 7494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2512 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2513 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 7506 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2517 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 7526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2536 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2541 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
 }
#line 7562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2570 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2571 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2576 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 7580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2577 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 7586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2582 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 7592 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2586 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 0; }
#line 7598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2587 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 1; }
#line 7604 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2588 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 2; }
#line 7610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2589 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 3; }
#line 7616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2590 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 4; }
#line 7622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2591 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 5; }
#line 7628 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2592 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 6; }
#line 7634 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2593 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 7; }
#line 7640 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2594 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 8; }
#line 7646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2600 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2601 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2603 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2609 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2610 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 7687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 7693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2613 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2614 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2615 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 7711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2616 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 7717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2617 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7723 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2618 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2619 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2620 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 7741 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2621 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 7747 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2622 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 7753 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2623 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 7759 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2624 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 7765 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2625 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 7771 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2626 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 7777 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2627 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 7783 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2628 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 7789 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2629 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 7795 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2630 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 7801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2631 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 7807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2632 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 7813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2633 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 7819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 7825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2635 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 7831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2636 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 7837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2637 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 7843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2638 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2639 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7855 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2640 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 7861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2641 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2642 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2643 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 7879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2644 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2645 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2646 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2647 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 7903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2648 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 7914 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2654 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7920 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2655 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2656 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2657 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2658 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2659 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2660 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 7956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2661 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 7962 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2662 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7968 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2664 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2665 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2666 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 7992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2667 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 7998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2668 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->llgr_time = (yyvsp[-1].i); }
#line 8004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2669 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 8010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2670 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 8016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2671 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 8022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2672 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 8028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2673 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = BGP_BFD_GRACEFUL; cf_check_bfd(1); }
#line 8034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2685 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 8042 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2691 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 8048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2692 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 8054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2693 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 8060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2694 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->filename = (yyvsp[0].t); }
#line 8066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2695 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->period = (yyvsp[0].i); }
#line 8072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2696 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 8078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2705 "cf-parse.y" /* yacc.c:1646  */
    { mrt_check_config(this_proto); }
#line 8084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2709 "cf-parse.y" /* yacc.c:1646  */
    { mrt_dump_cmd((yyvsp[-1].md)); }
#line 8090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2712 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 8096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2713 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 8102 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2714 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 8108 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2715 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 8114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2716 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 8120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2717 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 8126 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2724 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 8138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2740 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 8144 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2741 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 8150 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2742 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 8156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2743 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8162 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2744 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 8168 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2745 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 8174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2746 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8180 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2750 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 8198 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2765 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 8204 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2774 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 8210 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2775 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 8216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2776 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 8222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2777 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 8228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2778 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2779 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 8240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2780 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2781 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 8252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2782 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 8258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2783 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 8264 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2784 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 8270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2796 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 8281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2810 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 8287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2811 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 8293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2812 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 8299 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2816 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8305 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2817 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8311 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2826 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2827 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2828 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2829 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2830 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2831 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2832 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 8353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2833 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2834 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2835 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2839 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 8392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2858 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 8398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2859 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2860 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 8410 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2861 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8416 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2862 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8422 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2863 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8428 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2864 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2865 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2866 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8446 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2867 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8452 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2868 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2869 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8464 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2870 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8470 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2871 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2872 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2873 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 8488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2874 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 8494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2875 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2876 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 8506 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2877 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 8512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2878 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 8518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2879 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 8524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2880 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2881 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 8536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2883 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 8542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2884 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2885 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2886 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 8560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2887 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 8566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2888 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 8572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2889 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 8578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2890 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 8584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2891 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 8590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2892 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 8596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2893 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 8602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2894 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2895 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 8614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2896 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2907 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 8631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2917 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 8637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2918 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 8643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2927 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 2928 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 8655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 2932 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 8666 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 2941 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 8690 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 2964 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8696 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 2968 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 8702 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 2982 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8708 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 2988 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 8714 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 2991 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8720 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 2994 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 2999 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 8732 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3002 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 8738 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3007 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 8744 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3010 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 8750 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3014 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 8756 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3017 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 8764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 8770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3021 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 8776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3022 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 8782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3023 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 8788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 8794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3025 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 8800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 8806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 8812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3033 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 8821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3042 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 8831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3047 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 8837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3048 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 8843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3055 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 8858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 8864 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3069 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8870 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3070 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 8876 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3084 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 8902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3107 "cf-parse.y" /* yacc.c:1646  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 8935 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3137 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 8941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3138 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 8947 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3139 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 8953 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3140 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 8959 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3141 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 8965 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3142 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 8971 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3143 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 8980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3147 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 8986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3148 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 8992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3149 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 8998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3150 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 9004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3151 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 9010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3152 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 9016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3153 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 9022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3154 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 9028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3155 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 9034 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3156 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 9040 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3157 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 9046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3158 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 9052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3159 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 9058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3160 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 9064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3161 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 9070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3162 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 9076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3163 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 9082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3164 "cf-parse.y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 9088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3168 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 9094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3169 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 9100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3170 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3171 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3192 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3195 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3201 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 9133 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3210 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 9139 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3211 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 9145 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3212 "cf-parse.y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 9151 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3215 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 9163 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3225 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 9177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3234 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 9186 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3238 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 9194 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3244 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 9200 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3245 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 9206 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3249 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 9216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3254 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 9227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3260 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 9235 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3263 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 9244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3268 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3269 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9256 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3270 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9262 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3271 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3272 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 9274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3276 "cf-parse.y" /* yacc.c:1646  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 9280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3277 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 9286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3292 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 9292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 3300 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 9298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 3300 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 9304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 944:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 9310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 945:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 9316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 946:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 9322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 947:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 9328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 948:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 9334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 949:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 9340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 950:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 9346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 951:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 9352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 952:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 9358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 953:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 9364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 954:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 9370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 955:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 9376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 956:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 9382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 957:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 9388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 958:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 9394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 959:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 9400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 960:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 9406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 961:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 9412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 962:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 9418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 963:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 9424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 964:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 9430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 965:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 9436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 966:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 9442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 967:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 9448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 968:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 9454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 969:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 9460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 970:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 9466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 971:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 9472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 972:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 9478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 973:
#line 3303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 9484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 974:
#line 3304 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 9490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 975:
#line 3304 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
#line 9496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 976:
#line 3305 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 9502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 977:
#line 3306 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 9508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 978:
#line 3307 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 9514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 979:
#line 3308 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 9520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 980:
#line 3309 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 9526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 981:
#line 3310 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 9532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 982:
#line 3311 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 9538 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 983:
#line 3312 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 9544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 984:
#line 3313 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 9550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 985:
#line 3314 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 9556 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 986:
#line 3315 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 9562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 987:
#line 3316 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
#line 9568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 988:
#line 3316 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 9574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 989:
#line 3316 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 9580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 990:
#line 3316 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 9586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 991:
#line 3316 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 9592 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 992:
#line 3316 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 9598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 993:
#line 3316 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 9604 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 9608 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3318 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/mrt/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

